# ComputePipeline

[![ComputePipeline](https://github.com/MakieOrg/Makie.jl/actions/workflows/compute-pipeline.yml/badge.svg)](https://github.com/MakieOrg/Makie.jl/actions/workflows/compute-pipeline.yml)

The Makie computegraph package for reactive computations and conversions.
Replaces [Observables.jl](https://github.com/JuliaGizmos/Observables.jl) for Makie's internals.

The documentation is part of the Makie docs: https://docs.makie.org/dev/explanations/compute-pipeline#Compute-Pipeline


Quickstart:
```julia
graph = ComputeGraph()

# add inputs
add_input!(graph, :input1, 1)
add_input!((key, value) -> Float32(value), graph, :input2, 2) # directly converts

# add computations (edges + output nodes)
register_computation!(graph, [:input1, :input2], [:output]) do inputs, changed, last_output
    input1, input2 = inputs
    return (input1 + input2, )
end

# Observable like API:
map!((a, b) -> a + b, graph, [:input1, :input2], :output)
map!((a, b) -> ([a, b], [b, a]), graph, [:input1, :input2], [:ab, :ba])
```

# Individual components

@testset "Graph Initialization" begin
    parent = ComputeGraph()
    add_input!(parent, :in1, 1)
    graph = ComputeGraph()
    add_input!(graph, :in1, parent.in1)
    add_input!(graph, :in2, 2)
    foo(inputs, changed, cached) = (inputs[1] + inputs[2],)
    register_computation!(foo, graph, [:in1, :in2], [:merged])

    @testset "Overwrite Errors" begin
        @test_throws ErrorException add_input!(parent, :in1, 1)
        @test_throws ErrorException add_input!(graph, :in1, 1)
        @test_throws ErrorException add_input!(graph, :in2, 1)
        @test_throws ErrorException add_input!(graph, :in1, parent.in1)
        @test_throws ErrorException add_input!(graph, :in2, parent.in1)

        # different inputs, same function = different edge -> error
        @test_throws ErrorException register_computation!(foo, graph, [:in1], [:merged])

        # same inputs, same function = same edge, this should work and not change the existing callback
        # TODO: How do we test that the edge does not get updated (to a new edge with the same content)?
        #       Is objectid sufficient?
        @test begin
            id = objectid(graph[:merged].parent)
            register_computation!(foo, graph, [:in1, :in2], [:merged])
            id == objectid(graph[:merged].parent)
        end

        # same inputs, different function = different edge -> error
        goo(inputs, changed, cached) = (inputs[1] * inputs[2],)
        @test_throws ErrorException register_computation!(goo, graph, [:in1, :in2], [:merged])
    end
end

@testset "Graph Interaction" begin
    graph = ComputeGraph()
    add_input!(graph, :in1, 1)
    add_input!(graph, :in2, 2)
    register_computation!(graph, [:in1, :in2], [:merged]) do inputs, changed, cached
        return (inputs[1] + inputs[2],)
    end

    # Sanity checks
    @test haskey(graph.inputs, :in1) && haskey(graph.inputs, :in2)
    @test haskey(graph.outputs, :in1) && haskey(graph.outputs, :in2) && haskey(graph.outputs, :merged)

    @testset "Graph Access" begin
        @test graph.in1 === graph.outputs[:in1]
        @test graph.in2 === graph.outputs[:in2]
        @test graph.merged === graph.outputs[:merged]

        @test graph[:in1] === graph.outputs[:in1]
        @test graph[:in2] === graph.outputs[:in2]
        @test graph[:merged] === graph.outputs[:merged]
    end

    @test graph[:merged][] == 3 # prepare graph state

    function get_state(graph)
        i = graph.inputs; o = graph.outputs
        return Int.(isdirty.([i[:in1], i[:in2], o[:in1], o[:in2], o[:merged]]))
    end

    @testset "Graph Update" begin
        update!(graph, in1 = 5)
        @test graph.inputs[:in1].value[] == 5
        @test get_state(graph) == [1, 0, 1, 0, 1]
        @test graph[:merged][] == 7

        @test_throws ErrorException update!(graph, merged = 2)
        @test get_state(graph) == [0, 0, 0, 0, 0]
        @test graph[:merged][] == 7

        update!(graph, in2 = 4, in1 = 7)
        @test get_state(graph) == [1, 1, 1, 1, 1]
        @test graph[:merged][] == 11

        graph.in2 = 0
        @test graph.inputs[:in2].value[] == 0
        @test get_state(graph) == [0, 1, 0, 1, 1]
        @test graph[:merged][] == 7

        graph.in1[] = 3
        @test graph.inputs[:in1].value[] == 3
        @test graph.outputs[:in1].value[] == 7
        @test get_state(graph) == [1, 0, 1, 0, 1]
        @test graph[:merged][] == 3
    end

    @testset "Graph resolve" begin
        update!(graph, in1 = 2, in2 = 1)
        @test get_state(graph) == [1, 1, 1, 1, 1]
        @test graph.inputs[:in1].value[] == 2
        @test graph.inputs[:in2].value[] == 1
        @test graph.outputs[:in1].value[] == 3
        @test graph.outputs[:in2].value[] == 0

        # getproperty interface
        @test graph.in1[] == 2
        @test graph.outputs[:in1].value[] == 2
        @test get_state(graph) == [0, 1, 0, 1, 1]

        @test graph.in2[] == 1
        @test graph.outputs[:in2].value[] == 1
        @test get_state(graph) == [0, 0, 0, 0, 1]

        @test graph.merged === graph.outputs[:merged]

        update!(graph, in1 = -1, in2 = -2)
        @test get_state(graph) == [1, 1, 1, 1, 1]
        @test graph.inputs[:in1].value[] == -1
        @test graph.inputs[:in2].value[] == -2
        @test graph.outputs[:in1].value[] == 2
        @test graph.outputs[:in2].value[] == 1

        # getindex interface
        @test graph[:in1][] == -1
        @test graph.outputs[:in1].value[] == -1
        @test get_state(graph) == [0, 1, 0, 1, 1]

        @test graph[:in2][] == -2
        @test graph.outputs[:in2].value[] == -2
        @test get_state(graph) == [0, 0, 0, 0, 1]

        # verify that this isn't a multi-step resolve
        graph.inputs[:in1].value = 7

        @test graph[:merged][] == -3
        @test graph.outputs[:merged].value[] == -3
        @test get_state(graph) == [0, 0, 0, 0, 0]

        # verify with parent being another compute edge too
        register_computation!(graph, [:merged], [:output]) do inputs, changed, cached
            return (inputs[1][],)
        end
        graph.outputs[:in1].value[] = 12
        @test graph[:output][] == -3
        @test graph.outputs[:output].value[] == -3
        @test get_state(graph) == [0, 0, 0, 0, 0]
        @test !isdirty(graph[:output])

        # multi-step with compute edge
        update!(graph, in1 = 10)
        @test get_state(graph) == [1, 0, 1, 0, 1]
        @test isdirty(graph[:output])
        @test graph[:output][] == 8
        @test graph.outputs[:output].value[] == 8
        @test get_state(graph) == [0, 0, 0, 0, 0]
        @test !isdirty(graph[:output])
    end

    counter = Dict{Symbol, Int}()
    foreach(k -> counter[k] = 0, [:merged, :merged2, :zipped, :summed, :plus_one, :zipped2, :summed2, :plus_one2])
    graph = ComputeGraph()
    add_input!(graph, :in1, 1)
    add_input!(graph, :in2, 2)
    add_input!(graph, :in3, [1, 2, 3])
    # bitstype
    register_computation!(graph, [:in1, :in2], [:merged]) do inputs, changed, cached
        counter[:merged] += 1
        return (changed.in1 ? inputs[1] + inputs[2] : nothing,)
    end
    register_computation!(graph, [:merged], [:merged2]) do inputs, changed, cached
        counter[:merged2] += 1
        return (inputs.merged,)
    end
    # Array recreate
    register_computation!(graph, [:in1, :in3], [:zipped]) do inputs, changed, cached
        counter[:zipped] += 1
        return (inputs.in1 .+ inputs.in3,)
    end
    register_computation!(graph, [:zipped], [:summed]) do inputs, changed, cached
        counter[:summed] += 1
        return (sum(inputs.zipped),)
    end
    register_computation!(graph, [:summed], [:plus_one]) do inputs, changed, cached
        counter[:plus_one] += 1
        return (inputs.summed + 1,)
    end
    # Array overwrite/reuse
    register_computation!(graph, [:in1, :in3], [:zipped2]) do inputs, changed, cached
        output = isnothing(cached) ? [0, 0, 0] : cached.zipped2
        output .= inputs.in1 .+ inputs.in3
        counter[:zipped2] += 1
        return (output,)
    end
    register_computation!(graph, [:zipped2], [:summed2]) do inputs, changed, cached
        counter[:summed2] += 1
        return (sum(inputs.zipped2),)
    end
    register_computation!(graph, [:summed2], [:plus_one2]) do inputs, changed, cached
        counter[:plus_one2] += 1
        return (inputs.summed2 + 1,)
    end

    @testset "update skipping and changed" begin
        @testset "initialization" begin
            @test graph.merged2[] == 3
            @test counter[:merged] == 1
            @test counter[:merged2] == 1

            @test graph.plus_one[] == 10
            @test counter[:zipped] == 1
            @test counter[:summed] == 1
            @test counter[:plus_one] == 1

            @test graph.plus_one2[] == 10
            @test counter[:zipped2] == 1
            @test counter[:summed2] == 1
            @test counter[:plus_one2] == 1
        end

        @testset "explicit skip via return nothing" begin
            graph.in2 = 3
            @test graph.merged2[] == 3
            @test counter[:merged] == 2
            @test counter[:merged2] == 1
        end

        @testset "no skip" begin
            graph.in1 = 2
            @test graph.merged2[] == 5
            @test counter[:merged] == 3
            @test counter[:merged2] == 2

            graph.in1 = 5
            @test graph.merged2[] == 8
            @test counter[:merged] == 4
            @test counter[:merged2] == 3

            graph.in1 = 4
            graph.in2 = 5
            @test graph.merged2[] == 9
            @test counter[:merged] == 5
            @test counter[:merged2] == 4

            # from in1 updates
            @test graph.plus_one[] == 19
            @test counter[:zipped] == 2
            @test counter[:summed] == 2
            @test counter[:plus_one] == 2

            @test graph.plus_one2[] == 19
            @test counter[:zipped2] == 2
            @test counter[:summed2] == 2
            @test counter[:plus_one2] == 2

            # from in3 updates
            graph.in3 = [0, 1, 2]
            @test graph.plus_one[] == 16
            @test counter[:zipped] == 3
            @test counter[:summed] == 3
            @test counter[:plus_one] == 3

            @test graph.plus_one2[] == 16
            @test counter[:zipped2] == 3
            @test counter[:summed2] == 3
            @test counter[:plus_one2] == 3
        end

        @testset "same value skips" begin
            graph.in1 = 4
            @test graph.merged2[] == 9
            @test counter[:merged] == 5
            @test counter[:merged2] == 4

            # from in1
            @test graph.plus_one[] == 16
            @test counter[:zipped] == 3
            @test counter[:summed] == 3
            @test counter[:plus_one] == 3

            @test graph.plus_one2[] == 16
            @test counter[:zipped2] == 3
            @test counter[:summed2] == 3
            @test counter[:plus_one2] == 3

            # from in3
            graph.in3 = [0, 1, 2]
            @test graph.plus_one[] == 16
            @test counter[:zipped] == 3
            @test counter[:summed] == 3
            @test counter[:plus_one] == 3

            @test graph.plus_one2[] == 16
            @test counter[:zipped2] == 3
            @test counter[:summed2] == 3
            @test counter[:plus_one2] == 3

            # delayed same value
            graph.in3 = [2, 1, 0]
            @test graph.plus_one[] == 16
            @test counter[:zipped] == 4     # input: [2,1,0] != [0,1,2]
            @test counter[:summed] == 4     # input: [2,1,0] .+ 4 != [0,1,2] .+ 4
            @test counter[:plus_one] == 3   # input:       sum(^) == sum(^)

            @test graph.plus_one2[] == 16
            @test counter[:zipped2] == 4
            @test counter[:summed2] == 4
            @test counter[:plus_one2] == 3
        end

        @testset "Array edge case" begin
            graph.in3 = [3, 2, 1] # .+ 1
            graph.in1 = 3       #  - 1

            # new array generated, values match, update skipped
            @test graph.plus_one[] == 16
            @test counter[:zipped] == 5
            @test counter[:summed] == 4
            @test counter[:plus_one] == 3

            # old array reused, values can't be compared, update advances
            @test graph.plus_one2[] == 16
            @test counter[:zipped2] == 5
            @test counter[:summed2] == 5
            @test counter[:plus_one2] == 3
        end
    end
end

@testset "Graph io" begin
    parent = ComputeGraph()
    add_input!(parent, :in1, 1)
    graph = ComputeGraph()
    add_input!(graph, :in1, parent.in1)
    add_input!(graph, :in2, 2)
    foo2(inputs, changed, cached) = (inputs[1] + inputs[2], inputs[1] - inputs[2])
    register_computation!(foo2, graph, [:in1, :in2], [:added, :subtracted])
    bar(inputs, changed, cached) = (inputs[1],)
    register_computation!(bar, graph, [:added], [:output])
    register_computation!(bar, graph, [:output], [:output2])
    register_computation!(bar, graph, [:subtracted], [:output3])

    graph[:in1][]

    @testset "brief show()" begin
        # TODO: This counts edges in graph because part of graph continues parent - Should it?
        @test sprint(show, parent) == "ComputeGraph(1 input, 1 output, 5 edges)"
        @test sprint(show, graph) == "ComputeGraph(1 input, 7 outputs, 5 edges)"
        @test sprint(show, graph.inputs[:in2]) == "Input(:in2, 2)"
        @test sprint(show, graph[:in1]) == "Computed(:in1, 1)"
        @test sprint(show, graph[:in2]) == "Computed(:in2, #undef)"
        @test sprint(show, graph[:added].parent) == "ComputeEdge(foo2(…), 2 inputs, 2 outputs, 2 dependents)"
        @test sprint(show, graph[:output].parent) == "ComputeEdge(bar(…), 1 input, 1 output, 1 dependent)"
        @test sprint(show, graph[:output2].parent) == "ComputeEdge(bar(…), 1 input, 1 output, 0 dependents)"
    end

    @testset "brief show()" begin
        m = MIME"text/plain"()
        @test sprint(show, m, parent) == "ComputeGraph():\n  Inputs:\n    :in1 => Input(:in1, 1)\n\n  Outputs:\n    :in1 => Computed(:in1, 1)"
        @test sprint(show, m, graph) == "ComputeGraph():\n  Inputs:\n    :in2 => Input(:in2, 2)\n\n  Outputs:\n    :added      => Computed(:added, #undef)\n    :in1        => Computed(:in1, 1)\n    :in2        => Computed(:in2, #undef)\n    :output     => Computed(:output, #undef)\n    :output2    => Computed(:output2, #undef)\n    :output3    => Computed(:output3, #undef)\n    :subtracted => Computed(:subtracted, #undef)"

        # Work around function path that's printed
        s = sprint(show, m, graph.inputs[:in2])
        @test contains(s, "Input:\n  name:     :in2\n  value:    2\n  callback: identity(::Int64) @ ")
        @test contains(s, "\n  output:   ↻ Computed(:in2, #undef)\n  dependents:\n    ↻ ComputeEdge(foo2(…), 2 inputs, 2 outputs, 2 dependents)")

        @test sprint(show, m, graph[:in1]) == "Computed:\n  name = :in1\n  parent = ComputeEdge(compute_identity(…), 1 input, 1 output, 1 dependent) @ output 1\n  value = 1\n  dirty = false"
        @test sprint(show, m, graph[:in2]) == "Computed:\n  name = :in2\n  parent = Input(:in2, 2)\n  value = #undef\n  dirty = true"

        # regex needed for 1.6 which uses "NameTuple{(), Tuple{}}" instead o "@NamedTuple{}"
        s = sprint(show, m, graph[:added].parent)
        @test contains(s, r"ComputeEdge:\n  callback:\n    foo2\(::@?NamedTuple\{.*\}, ::@?NamedTuple\{.*\}, ::Nothing\)\n    @ ")
        @test contains(s, "\n  inputs:\n    ↻ Computed(:in1, 1)\n    ↻ Computed(:in2, #undef)\n  outputs:\n    ↻ Computed(:added, #undef)\n    ↻ Computed(:subtracted, #undef)\n  dependents:\n    ↻ ComputeEdge(bar(…), 1 input, 1 output, 1 dependent)\n    ↻ ComputeEdge(bar(…), 1 input, 1 output, 0 dependents)")

        s = sprint(show, m, graph[:output].parent)
        @test contains(s, r"ComputeEdge:\n  callback:\n    bar\(::@?NamedTuple\{.*\}, ::@?NamedTuple\{.*\}, ::Nothing\)\n    @ ")
        @test contains(s, "\n  inputs:\n    ↻ Computed(:added, #undef)\n  outputs:\n    ↻ Computed(:output, #undef)\n  dependents:\n    ↻ ComputeEdge(bar(…), 1 input, 1 output, 0 dependents)")

        s = sprint(show, m, graph[:output2].parent)
        @test contains(s, r"ComputeEdge:\n  callback:\n    bar\(::@?NamedTuple\{.*\}, ::@?NamedTuple\{.*\}, ::Nothing\)\n    @ ")
        @test contains(s, "\n  inputs:\n    ↻ Computed(:output, #undef)\n  outputs:\n    ↻ Computed(:output2, #undef)\n  dependents:")
    end
end

@testset "deletion" begin
    foo(inputs, changed, cached) = (inputs[1],)
    foo2(inputs, changed, cached) = (inputs[1] + inputs[2], inputs[1] - inputs[2])

    @testset "public interface" begin
        graph = ComputeGraph()
        add_input!(graph, :in, 1)
        register_computation!(foo, graph, [:in], [:out])

        # These should not be available
        @test_throws MethodError delete!(graph, graph.inputs[:in]) # Input
        @test_throws MethodError delete!(graph, graph.outputs[:in]) # Computed
        @test_throws MethodError delete!(graph, graph.outputs[:out].parent) # ComputeEdge

        @test_throws KeyError delete!(graph, :unknown)

        @test begin
            delete!(graph, :out); true
        end
    end

    @testset "Input" begin
        graph = ComputeGraph()
        add_input!(graph, :in, 1)

        # Deleting an input should be possible and delete both the Input and the
        # related Computed if there are no obstructions
        @test haskey(graph.inputs, :in)
        @test haskey(graph.outputs, :in)
        delete!(graph, :in)
        @test !haskey(graph.inputs, :in)
        @test !haskey(graph.outputs, :in)

        add_input!(graph, :in, 1)
        @test haskey(graph.inputs, :in)
        @test haskey(graph.outputs, :in)

        register_computation!(foo, graph, [:in], [:out])

        # Deleting an input node with dependents is not allowed
        @test_throws ErrorException delete!(graph, :in)

        # Unless you allow deleting child nodes
        delete!(graph, :in, recursive = true)
        @test !haskey(graph.inputs, :in)
        @test !haskey(graph.outputs, :in)
        @test !haskey(graph.outputs, :out)
    end

    @testset "Computed" begin
        parent = ComputeGraph()
        add_input!(parent, :parent_node, 1)

        graph = ComputeGraph()
        add_input!(graph, :in1, parent.parent_node)
        add_input!(graph, :in2, 2)

        # Deleting a leaf node without siblings is valid
        @testset "Leaf Node" begin
            # ... with a Computed --> Computed --> Computed
            register_computation!(foo, graph, [:in1], [:output])

            @test haskey(graph.outputs, :output)
            @test !isempty(graph.outputs[:in1].parent.dependents)
            delete!(graph, :output)
            @test !haskey(graph.outputs, :output)
            @test isempty(graph.outputs[:in1].parent.dependents)

            # ... with a Input --> Computed --> Computed
            register_computation!(foo, graph, [:in2], [:output])

            @test haskey(graph.outputs, :output)
            @test !isempty(graph.outputs[:in2].parent.dependents)
            delete!(graph, :output)
            @test !haskey(graph.outputs, :output)
            @test isempty(graph.outputs[:in2].parent.dependents)
        end

        # Deleting a leaf node with siblings requires force = true
        @testset "Siblings" begin
            register_computation!(foo2, graph, [:in1, :in2], [:added, :subtracted])

            @test_throws ErrorException delete!(graph, :added)
            @test !isempty(graph.outputs[:in1].parent.dependents)
            @test !isempty(graph.outputs[:in2].parent.dependents)
            @test haskey(graph.outputs, :added)
            @test haskey(graph.outputs, :subtracted)

            delete!(graph, :added, force = true)
            @test isempty(graph.outputs[:in1].parent.dependents)
            @test isempty(graph.outputs[:in2].parent.dependents)
            @test !haskey(graph.outputs, :added)
            @test !haskey(graph.outputs, :subtracted)

            # check symmetry
            register_computation!(foo2, graph, [:in1, :in2], [:added, :subtracted])
            @test_throws ErrorException delete!(graph, :subtracted)
            @test !isempty(graph.outputs[:in1].parent.dependents)
            @test !isempty(graph.outputs[:in2].parent.dependents)
            @test haskey(graph.outputs, :added)
            @test haskey(graph.outputs, :subtracted)

            delete!(graph, :subtracted, force = true)
            @test isempty(graph.outputs[:in1].parent.dependents)
            @test isempty(graph.outputs[:in2].parent.dependents)
            @test !haskey(graph.outputs, :added)
            @test !haskey(graph.outputs, :subtracted)
        end

        # Deleting a node with further children requires recursive = true
        @testset "Children" begin
            register_computation!(foo, graph, [:in1], [:output])
            register_computation!(foo, graph, [:output], [:output2])

            @test_throws ErrorException delete!(graph, :output)
            @test haskey(graph.outputs, :output)
            @test haskey(graph.outputs, :output2)
            @test !isempty(graph.outputs[:in1].parent.dependents)
            @test !isempty(graph.outputs[:output].parent.dependents)

            delete!(graph, :output, recursive = true)
            @test !haskey(graph.outputs, :output)
            @test !haskey(graph.outputs, :output2)
            @test isempty(graph.outputs[:in1].parent.dependents)
        end

        # Nodes that connect one graph to another should follow the same rules
        # as normal nodes
        @testset "Graph Connector Node" begin
            @test haskey(parent.outputs, :parent_node)
            @test haskey(graph.outputs, :in1)
            @test !isempty(parent.outputs[:parent_node].parent.dependents)
            @test isempty(graph.outputs[:in1].parent.dependents)

            @test_throws KeyError delete!(graph, :parent_node)

            delete!(graph, :in1)
            @test haskey(parent.outputs, :parent_node)
            @test !haskey(graph.outputs, :in1)
            @test isempty(parent.outputs[:parent_node].parent.dependents)

            add_input!(graph, :in1, parent.parent_node)
            register_computation!(foo, graph, [:in1], [:output])

            @test haskey(parent.outputs, :parent_node)
            @test haskey(graph.outputs, :in1)
            @test haskey(graph.outputs, :output)
            @test !isempty(parent.outputs[:parent_node].parent.dependents)
            @test !isempty(graph.outputs[:in1].parent.dependents)
            @test isempty(graph.outputs[:output].parent.dependents)

            @test_throws ErrorException delete!(graph, :in1)

            delete!(graph, :in1, recursive = true)
            @test haskey(parent.outputs, :parent_node)
            @test !haskey(graph.outputs, :in1)
            @test !haskey(graph.outputs, :output)
            @test isempty(parent.outputs[:parent_node].parent.dependents)

            # TODO:: Anything special for graph barriers?
        end
    end

end

@testset "Observables" begin
    @testset "Synchronization" begin
        g = ComputeGraph()
        add_input!((k, x) -> Float32.(x), g, :input1, [0])
        add_input!((k, x) -> Float32.(x), g, :input2, [1])
        register_computation!(g, [:input1, :input2], [:xy, :yx]) do (x, y), changed, cached
            return ([x; y], [y; x])
        end
        map!(x -> [x; 1], g, :xy, :out1)
        map!(x -> [x; 1], g, :yx, :out2)
        map!((x, y) -> tuple.(x, y), g, [:out1, :out2], :zipped)
        foreach(key -> ComputePipeline.get_observable!(g, key), keys(g.outputs))

        @testset "Initialization" begin
            @test haskey(g, :input1)
            @test haskey(g, :input2)
            @test haskey(g, :xy)
            @test haskey(g, :yx)
            @test haskey(g, :out1)
            @test haskey(g, :out2)
            @test haskey(g, :zipped)

            @test g.observables[:input1][] == Float32[0]
            @test g.observables[:input2][] == Float32[1]
            @test g.observables[:xy][] == Float32[0, 1]
            @test g.observables[:yx][] == Float32[1, 0]
            @test g.observables[:out1][] == Float32[0, 1, 1]
            @test g.observables[:out2][] == Float32[1, 0, 1]
            @test g.observables[:zipped][] == [(0.0f0, 1.0f0), (1.0f0, 0.0f0), (1.0f0, 1.0f0)]
        end

        @testset "Update" begin
            ComputePipeline.update!(g, input1 = [2, 3], input2 = [6, 7])

            @test g.observables[:input1][] == Float32[2, 3]
            @test g.observables[:input2][] == Float32[6, 7]
            @test g.observables[:xy][] == Float32[2, 3, 6, 7]
            @test g.observables[:yx][] == Float32[6, 7, 2, 3]
            @test g.observables[:out1][] == Float32[2, 3, 6, 7, 1]
            @test g.observables[:out2][] == Float32[6, 7, 2, 3, 1]
            @test g.observables[:zipped][] == tuple.(Float32[2, 3, 6, 7, 1], Float32[6, 7, 2, 3, 1])
        end
    end

    @testset "map and on" begin
        g = ComputeGraph()
        add_input!((k, x) -> Float64.(x), g, :input1, 0)
        add_input!((k, x) -> Float64.(x), g, :input2, 4)
        register_computation!(g, [:input1, :input2], [:xy, :yx]) do (x, y), changed, cached
            return (x - y, y - x)
        end
        map!(x -> x + 1, g, :xy, :out1)
        map!(x -> x + 1, g, :yx, :out2)
        map!((x, y) -> x * y, g, [:out1, :out2], :mult)

        @test isempty(g.observables)

        obs = Observable{Any}()
        on(x -> obs[] = x, g[:mult])
        @test_throws UndefRefError obs[]
        @test haskey(g.observables, :mult)
        @test length(g.observables) == 1
        update!(g, input1 = 1)

        obs2 = map(x -> 2 .* x, g.out2)
        @test obs2[] == 8.0
        @test haskey(g.observables, :out2)
        @test length(g.observables) == 2

        obs3 = Observable{Any}()
        map!(*, obs3, g.input1, g.out1)
        @test obs3[] == -2.0
        @test haskey(g.observables, :input1)
        @test haskey(g.observables, :out1)
        @test length(g.observables) == 4

        counter = Ref(0)
        onany(obs, obs2, obs3) do args...
            counter[] += 1
            return
        end
        ComputePipeline.update!(g, input1 = 2, input2 = 8)
        @test counter[] == 4
    end

    @testset "Infinite loops" begin
        g = ComputeGraph()
        add_input!(g, :resample, 1)
        register_computation!(g, [:resample], [:output]) do (resample,), changed, cached
            data = isnothing(cached) ? collect(1:10) : cached[1]
            return (resample > 0 ? shuffle!(data) : data,)
        end
        obs = ComputePipeline.get_observable!(g, :output)

        update_counter = Ref(0)
        on(x -> update_counter[] += 1, obs)
        @testset "Problem" begin
            # Updating mutable data to the same value can cause infinite loops
            # if the Observable also updates (and then loops back into the graph)
            # We want this to never trigger:
            prev = deepcopy(g[:output][])
            @test g[:output][] !== prev # Sanity check
            @test obs[] !== prev # Sanity check
            for i in 1:10
                update!(g, resample = -i) # don't change data
                @test g[:output][] == prev # Sanity check
                @test obs[] == prev # Sanity check
                @test update_counter[] == 0
            end

            # And updating still works
            prev = deepcopy(g[:output][])
            update_counter[] = 0
            @test g[:output][] !== prev # Sanity check
            @test obs[] !== prev # Sanity check
            for i in 1:10
                prev = deepcopy(g[:output][])
                update!(g, resample = i) # shuffle data
                @test g[:output][] != prev # Sanity check
                @test obs[] != prev # Sanity check
                @test obs[] == g[:output][]
                @test update_counter[] == i
            end

            # Mixed for good measure
            prev = deepcopy(g[:output][])
            update_counter[] = 0
            expected = 0
            for i in 1:30
                choice = rand(Int)
                prev = deepcopy(g[:output][])
                update!(g, resample = choice) # maybe shuffle data
                if choice > 0
                    expected += 1
                    @test obs[] != prev
                else
                    @test obs[] == prev
                end
                @test obs[] == g[:output][]
                @test update_counter[] == expected
            end
        end

        @testset "Solution" begin
            # Keep observable and compute data distinguishable
            @test obs[] == g[:output][]
            @test obs[] !== g[:output][]

            for i in 1:10
                update!(g, resample = -i)
                @test obs[] == g[:output][]
                @test obs[] !== g[:output][]
            end

            for i in 1:10
                update!(g, resample = i)
                @test obs[] == g[:output][]
                @test obs[] !== g[:output][]
            end

            for i in 1:30
                choice = rand(Int)
                update!(g, resample = choice)
                @test obs[] == g[:output][]
                @test obs[] !== g[:output][]
            end
        end
    end
end

@testset "mark_resolved" begin
    @testset "Input" begin
        graph = ComputeGraph()
        add_input!(graph, :in, 1)
        map!(identity, graph, :in, :out)
        @test graph.out[] == 1
        @test !ComputePipeline.isdirty(graph.out)

        graph.in = 2
        @test ComputePipeline.isdirty(graph.out)
        ComputePipeline.mark_resolved!(graph.out)
        @test !ComputePipeline.isdirty(graph.out)
        @test graph.out[] == 1

        graph.in = 3
        @test ComputePipeline.isdirty(graph.out)
        @test graph.out[] == 3
    end

    @testset "ComputeEdge" begin
        g = ComputeGraph()
        add_input!(g, :input1, 0)
        add_input!(g, :input2, 1)
        map!(x -> x + 1, g, :input1, :out1)
        map!(x -> x + 1, g, :input2, :out2)
        map!(tuple, g, [:out1, :out2], :output)

        @test g.output[] == (1, 2)
        @test !ComputePipeline.isdirty(g.output)

        g.input1 = 2
        @test ComputePipeline.isdirty(g.output)
        ComputePipeline.mark_resolved!(g.output)
        @test !ComputePipeline.isdirty(g.output)
        @test g.output[] == (1, 2)

        g.input2 = 2
        @test ComputePipeline.isdirty(g.output)
        @test g.output[] == (3, 3)

        g.input1 = 0
        ComputePipeline.mark_resolved!(g.output)
        @test g.output[] == (3, 3)
        g.input1 = 1
        @test g.output[] == (2, 3)
    end
end

@testset "Validation" begin
    graph = ComputeGraph()
    add_input!(graph, :a, 1)

    @test_throws ErrorException add_input!(graph, :b, Ref(graph.a))
    @test_throws ErrorException add_input!(graph, :c, Ref(graph.inputs[:a]))
    @test_throws ErrorException add_input!(graph, :d, graph.inputs[:a])

    # add_input!() processes this, so we need to check more manually
    graph.outputs[:dummy] = ComputePipeline.Computed(:dummy)
    @test_throws ErrorException ComputePipeline.Input(graph, :e, graph.a, identity, graph.dummy)

    @test_throws ErrorException ComputePipeline.Computed(:f, Ref(Ref(graph.a)))
    @test_throws ErrorException ComputePipeline.Computed(:g, Ref(graph.a))
    @test_throws ErrorException ComputePipeline.Computed(:h, Ref(Ref(graph.inputs[:a])))
    @test_throws ErrorException ComputePipeline.Computed(:i, Ref(graph.inputs[:a]))

    map!(x -> graph.a, graph, :a, :j)
    @test_throws ResolveException{ErrorException} graph.j[]
end

@testset "mixed-map" begin
    graph1 = ComputeGraph()
    add_input!(graph1, :a1, 1)

    graph2 = ComputeGraph()
    add_input!(graph2, :a2, 1)

    map!(+, graph1, [graph1[:a1], graph2[:a2]], :merged1)
    e1 = graph1.merged1.parent
    @test e1.inputs == [graph1.a1, graph2.a2]

    map!(+, graph1, [:a1, graph2[:a2]], :merged2)
    e2 = graph1.merged2.parent
    @test e2.inputs == [graph1.a1, graph2.a2]

    map!(+, graph2, [graph1[:a1], :a2], :merged3)
    e3 = graph2.merged3.parent
    @test e3.inputs == [graph1.a1, graph2.a2]
end

@testset "compute_identity" begin
    graph1 = ComputeGraph()
    add_input!(graph1, :a1, Ref{Any}(1))
    map!(x -> Ref{Any}(x), graph1, :a1, :b1)

    graph2 = ComputeGraph()
    add_input!(graph2, :b1, graph1.b1)
    graph2.b1[]
    @test graph2.b1.value isa Ref{Any}

    edge = graph2.b1.parent
    @test edge.callback == ComputePipeline.compute_identity
    @test length(edge.inputs) == length(edge.outputs)
    for (in, out) in zip(edge.inputs, edge.outputs)
        @test in.value === out.value
        @test !ComputePipeline.isdirty(in)
        @test !ComputePipeline.isdirty(out)
    end

    update!(graph1, a1 = 5.0)

    for (in, out) in zip(edge.inputs, edge.outputs)
        @test in.value === out.value
        @test ComputePipeline.isdirty(in)
        @test ComputePipeline.isdirty(out)
    end

    graph1.b1[]

    for (in, out) in zip(edge.inputs, edge.outputs)
        @test in.value === out.value
        @test !ComputePipeline.isdirty(in)
        @test ComputePipeline.isdirty(out)
    end

    graph2.b1[]

    for (in, out) in zip(edge.inputs, edge.outputs)
        @test in.value === out.value
        @test !ComputePipeline.isdirty(in)
        @test !ComputePipeline.isdirty(out)
    end
end

@testset "is_same NaN and missing" begin
    # vectors
    v = [NaN, missing, 1]
    @test ComputePipeline.is_same(v, copy(v))
    @test !ComputePipeline.is_same(v, v)

    # Dicts with NaN
    d = Dict(:a => NaN, :b => missing, :c => 1)
    @test ComputePipeline.is_same(d, copy(d))
    @test !ComputePipeline.is_same(d, d)
end

@testset "map_latest!" begin
    @testset "Basic functionality" begin
        graph = ComputeGraph()
        add_input!(graph, :input, 1)

        # Simple computation with single input and output
        map_latest!(graph, [:input], [:output]) do x
            return (x * 2,)
        end

        # First call should block until result is ready
        @test graph[:output][] == 2

        # Update and verify it computes the new value
        update!(graph, input = 5)
        graph[:output][] # poll
        sleep(0.1)
        # Force resolution to pick up the new value
        @test graph[:output][] == 10
    end

    @testset "Multiple inputs and outputs" begin
        graph = ComputeGraph()
        add_input!(graph, :a, 1)
        add_input!(graph, :b, 2)

        map_latest!(graph, [:a, :b], [:sum, :product]) do a, b
            return (a + b, a * b)
        end

        @test graph[:sum][] == 3
        @test graph[:product][] == 2

        update!(graph, a = 3, b = 4)
        graph[:sum][]  # poll
        sleep(0.3)
        # Check results - these will force resolution
        @test graph[:sum][] == 7
        @test graph[:product][] == 12
    end

    @testset "Skips intermediate updates" begin
        graph = ComputeGraph()
        add_input!(graph, :input, 0)

        computation_count = Ref(0)
        processed_values = Int[]

        map_latest!(graph, [:input], [:output]) do x
            computation_count[] += 1
            push!(processed_values, x)
            sleep(0.2)  # Simulate slow computation
            return (x * 2,)
        end

        # Initialize
        @test graph[:output][] == 0
        @test computation_count[] == 1

        # Rapidly update multiple times
        for i in 1:5
            update!(graph, input = i)
        end

        # Wait for computation to complete
        graph[:output][]  # poll
        sleep(0.5)

        # Access the result - this forces resolution
        result = graph[:output][]

        # Should have processed initial + final value(s), but not all intermediate ones
        @test computation_count[] == 2  # Less than initial + all 5 updates
        @test result == 10  # Final value (5 * 2)
    end

    @testset "Returns previous value while computing" begin
        graph = ComputeGraph()
        add_input!(graph, :input, 1)

        map_latest!(graph, [:input], [:output]) do x
            sleep(0.3)  # Simulate slow computation
            return (x * 10,)
        end

        # Get initial value
        @test graph[:output][] == 10

        # Update with new value
        update!(graph, input = 2)

        # Immediately check - should return previous value while computing
        prev_value = graph[:output][]
        @test prev_value == 10  # Still the old value

        # Wait for computation to finish
        sleep(0.6)

        # Now should have new value
        @test graph[:output][] == 20
    end

    @testset "spawn parameter" begin
        graph = ComputeGraph()
        add_input!(graph, :input, 5)

        # Test with spawn=false (runs on current task)
        map_latest!(graph, [:input], [:output]; spawn = false) do x
            return (x + 1,)
        end

        @test graph[:output][] == 6

        update!(graph, input = 10)
        graph[:output][] # poll
        sleep(0.2)
        @test graph[:output][] == 11
    end

    @testset "Computation updates trigger correctly" begin
        graph = ComputeGraph()
        add_input!(graph, :input, 1)

        update_count = Ref(0)

        map_latest!(graph, [:input], [:output]) do x
            sleep(0.05)
            return (x * 3,)
        end

        # Initialize
        @test graph[:output][] == 3

        # Set up an observable listener to count updates
        obs = ComputePipeline.get_observable!(graph, :output)
        on(obs) do val
            update_count[] += 1
        end

        # Update input
        update!(graph, input = 2)
        sleep(0.3)

        # Should have triggered at least one update
        @test update_count[] >= 1
        @test graph[:output][] == 6
    end
end

@testset "explicit node initialization" begin
    calls = 0
    graph = ComputeGraph()
    add_input!(graph, :x, 1)
    add_input!(graph, :y, 2)
    map!(graph, [:x, :y], [:xy, :yx]) do x, y
        calls += 1
        return (x + y, x - y)
    end
    map!(x -> 2x, graph, :xy, :z)

    @testset "Initial State" begin
        @test isdirty(graph.x)
        @test isdirty(graph.y)
        @test isdirty(graph.xy)
        @test isdirty(graph.yx)
        @test isdirty(graph.z)
    end

    @testset "Partial output init doesn't init edge" begin
        ComputePipeline.unsafe_init!(graph.xy, 1)

        @test isdirty(graph.x)
        @test isdirty(graph.y)
        @test isdirty(graph.xy)
        @test isdirty(graph.yx)
        @test isdirty(graph.z)
        @test ComputePipeline.is_initialized(graph.xy)
        @test !ComputePipeline.is_initialized(graph.yx)
        @test graph.xy.value[] == 1
        @test !isassigned(graph.xy.parent.typed_edge)
        @test calls == 0
    end

    @testset "Partial output init doesn't break normal init" begin
        @test graph.z[] == 6
        @test calls == 1
    end

    calls = 0
    graph = ComputeGraph()
    add_input!(graph, :x, 1)
    add_input!(graph, :y, 2)
    map!(graph, [:x, :y], [:xy, :yx]) do x, y
        calls += 1
        return (x + y, x - y)
    end
    map!(x -> 2x, graph, :xy, :z)
    ComputePipeline.unsafe_init!(graph.xy, 1)

    @testset "Verify reset" begin
        @test isdirty(graph.x)
        @test isdirty(graph.y)
        @test isdirty(graph.xy)
        @test isdirty(graph.yx)
        @test isdirty(graph.z)
        @test ComputePipeline.is_initialized(graph.xy)
        @test !ComputePipeline.is_initialized(graph.yx)
        @test graph.xy.value[] == 1
        @test !isassigned(graph.xy.parent.typed_edge)
        @test calls == 0
    end

    @testset "Full output init does init edge" begin
        ComputePipeline.unsafe_init!(graph.yx, Base.Ref{Any}(2))

        @test !isdirty(graph.x)
        @test !isdirty(graph.y)
        @test !isdirty(graph.xy)
        @test !isdirty(graph.yx)
        @test isdirty(graph.z)
        @test ComputePipeline.is_initialized(graph.xy)
        @test ComputePipeline.is_initialized(graph.yx)
        @test isassigned(graph.xy.parent.typed_edge)
        @test calls == 0
        @test graph.xy.value[] == 1
        @test graph.yx.value[] == 2
        @test calls == 0
        @test !ComputePipeline.is_initialized(graph.z)
        @test graph.z[] == 2
        @test calls == 0
    end

    @testset "updates still work" begin
        graph.x = 2
        @test isdirty(graph.x)
        @test !isdirty(graph.y)
        @test isdirty(graph.xy)
        @test isdirty(graph.z)
        @test calls == 0
        @test graph.xy[] == 4
        @test graph.z[] == 8
        @test calls == 1
    end

    @testset "error on double init" begin
        @test_throws ErrorException ComputePipeline.unsafe_init!(graph.xy, 0)
    end
end

@testset "Array memory aliasing" begin
    M = fill(0, 2, 2)
    graph = ComputeGraph()
    add_input!(graph, :mat, M)
    map!(vec, graph, :mat, :vec)
    map!(v -> Float32.(v), graph, :vec, :vecf)
    v = graph.vec[]
    M .= 1
    graph.mat = M
    @assert pointer(v) == pointer(graph.vec[]) "this is expected to be memory aliased, but isn't"
    @test graph.vecf[] == [1, 1, 1, 1]
end

module ComputePipeline

using Preferences

const ENABLE_COMPUTE_CHECKS = @load_preference("ENABLE_COMPUTE_CHECKS", false)

enable_debugging!() = set_debug!(true)
disable_debugging!() = set_debug!(false)
function set_debug!(value::Bool)
    if value != ENABLE_COMPUTE_CHECKS
        @set_preferences!("ENABLE_COMPUTE_CHECKS" => value)
        @info "Changing the debug mode requires restarting Julia to take effect!"
    end
    return
end

using Observables

using Base: RefValue, tail

deref(r::RefValue) = r[]
deref(x) = x

abstract type AbstractEdge end

"""
    struct Computed

A `Computed` represents a node in the `ComputeGraph`. It should not be created
directly but be generated by [`add_input!`](@ref) or [`register_computation!`](@ref).

A `Computed` can be accessed from the graph by `graph[:name]` where `:name` is
the name the node was created with. Its value is returned by `graph[:name][]`
which also runs any pending updates.
"""
mutable struct Computed
    name::Symbol
    # if a parent edge got resolved and updated this computed, dirty is temporarily true
    # so that the edges dependents can update their inputs accordingly
    dirty::Bool

    value::RefValue
    parent::AbstractEdge
    parent_idx::Int # index of parent.outputs this value refers to
    Computed(name) = new(name, false)
    function Computed(name, value::RefValue)
        validate_node_value(value)
        return new(name, false, value)
    end
    function Computed(name, value::RefValue, parent::AbstractEdge, idx::Integer)
        validate_node_value(value)
        return new(name, false, value, parent, idx)
    end
    function Computed(name, edge::AbstractEdge, idx::Integer)
        p = new(name, false)
        p.parent = edge
        p.parent_idx = idx
        return p
    end
end

hasparent(computed::Computed) = isdefined(computed, :parent)
getparent(computed::Computed) = hasparent(computed) ? computed.parent : nothing

struct ResolveException{E <: Exception} <: Exception
    start::Computed
    error::E
end

struct TypedEdge{InputTuple, OutputTuple, F}
    callback::F
    inputs::InputTuple
    inputs_dirty::Vector{Bool}
    outputs::OutputTuple
    output_nodes::Vector{Computed}
end

"""
    struct ComputeEdge

A `ComputeEdge` represents the computation connecting one set of nodes to another.
They are considered internal and should not be interacted with or created directly.
"""
struct ComputeEdge{T} <: AbstractEdge
    graph::T
    callback::Function

    inputs::Vector{Computed}
    inputs_dirty::Vector{Bool}

    outputs::Vector{Computed}
    got_resolved::RefValue{Bool}

    # edges, that rely on outputs from this edge
    # Mainly needed for mark_dirty!(edge) to propagate to all dependents
    dependents::Vector{ComputeEdge{T}}
    typed_edge::RefValue{TypedEdge}
end


function ComputeEdge(f, graph::T, input::Computed, output::Computed) where {T}
    return ComputeEdge{ComputeGraph}(
        graph, f, [input], [true], [output], RefValue(false),
        ComputeEdge[], RefValue{TypedEdge}()
    )
end

function _get_named_change(::NamedTuple{Names}, dirty) where {Names}
    values = ntuple(i -> dirty[i], length(Names))
    return NamedTuple{Names, NTuple{length(Names), Bool}}(values)
end

function TypedEdge(edge::ComputeEdge)
    N = length(edge.inputs)
    names = ntuple(i -> edge.inputs[i].name, N)
    values = ntuple(i -> edge.inputs[i].value, N)
    inputs = NamedTuple{names}(values)
    # force `callback` and `inputs` types to be inferred so the rest of the
    # constructor can be type stable
    return Base.invokelatest(TypedEdge, edge, edge.callback, inputs)
end

function TypedEdge(edge::ComputeEdge, f, inputs)
    dirty = _get_named_change(inputs, edge.inputs_dirty)

    result = f(map(getindex, inputs), dirty, nothing)

    if result isa Tuple

        if !all(is_node_value_valid, result)
            invalid_results = [output.name => value for (output, value) in zip(edge.outputs, result) if !is_node_value_valid(value)]
            strings = map(kv -> "$(kv[1]) = ::$(typeof(kv[2]))", invalid_results)
            str = join(strings, ", ")
            error("Edge callback returned invalid types for outputs: [$str]")
        end

        if length(result) != length(edge.outputs)
            m = first(methods(edge.callback))
            line = string(m.file, ":", m.line)
            error("Result needs to have same length. Found: $(result), for func $(line)")
        end

        outputs = ntuple(length(result)) do i
            v = result[i] isa RefValue ? result[i] : RefValue(result[i])
            edge.outputs[i].value = v # initialize to fully typed RefValue
            return v
        end
        foreach(node -> node.dirty = true, edge.outputs)

    elseif isnothing(result)

        outputs = ntuple(length(edge.outputs)) do i
            v = RefValue(nothing)
            edge.outputs[i].value = v # initialize to fully typed RefValue
            return v
        end
        foreach(node -> node.dirty = false, edge.outputs)

    else
        error("Wrong type as result $(typeof(result)). Needs to be Tuple with one element per output or nothing. Value: $result")
    end
    return TypedEdge(f, inputs, edge.inputs_dirty, outputs, edge.outputs)
end


"""
    struct Input

A `Input` represents an entry point to the `ComputeGraph`. Like [`Computed`](@ref)
it should not be created directly, but rely on [`add_input!`](@ref). It should
be updated by `update!(graph, input_name = new_value)` to correctly update the
state of the compute graph.
"""
mutable struct Input{T} <: AbstractEdge
    graph::T
    name::Symbol
    value::Any
    f::Function
    output::Computed
    dirty::Bool
    dependents::Vector{ComputeEdge{T}}
end

Base.setproperty!(::Input, ::Symbol, ::Observable) = error("Setting the value of an ::Input to an Observable is not allowed")
Base.setproperty!(::Input, ::Symbol, ::Computed) = error("Setting the value of an ::Input to a Computed is not allowed")

function Input(graph, name, value, f, output)
    validate_node_value(value)
    return Input{ComputeGraph}(graph, name, value, f, output, true, ComputeEdge[])
end


"""
    ComputeGraph()

Creates a new empty `ComputeGraph`.

Inputs can be added to the graph using [`add_input`](@ref). Computations and the
connected outputs can be added with [`register_computation!`](@ref).

To update an input, `update!(graph, input_name = new_value)` can be used. To get
an up-to-date value from an output use `graph[:output_name][]`.

## Example:

```
graph = ComputeGraph()

add_input!(graph, :first_node, 1)
register_computation!(graph, [:first_node], [:derived_node]) do inputs, changed, cached
    return (2 * inputs[1][], )
end

update!(graph, first_node = 2)
graph[:derived_node][]
```
"""
struct ComputeGraph
    inputs::Dict{Symbol, Input}
    outputs::Dict{Symbol, Computed}
    lock::ReentrantLock

    onchange::Observable{Set{Symbol}}
    observables::Dict{Symbol, Observable}
    should_deepcopy::Set{Symbol}
    observerfunctions::Vector{Observables.ObserverFunction}
    obs_to_update::Vector{Observable}
end

validate_node_value(x) = nothing
validate_node_value(x::RefValue) = isassigned(x) ? validate_node_value(x[]) : nothing
# shouldn't have those in input.value or computed.value[]
function validate_node_value(::Union{T, RefValue{T}}) where {T <: Union{Computed, Input, ComputeGraph, ComputeEdge}}
    error("The value of a compute node is not allowed to be of type ::$T.")
end

is_node_value_valid(x) = true
is_node_value_valid(x::RefValue) = isassigned(x) ? is_node_value_valid(x[]) : true
# shouldn't have those in input.value or computed.value[]
function is_node_value_valid(::Union{T, RefValue{T}}) where {T <: Union{Computed, Input, ComputeGraph, ComputeEdge}}
    return false
end

"""
    get_observable!(graph::ComputeGraph, key::Symbol[; use_deepcopy = true])

Returns an observable which contains the up to date value of the graph node with name `key`.

Note that in order for the Observable to be up to date, the respective node needs
to resolve immediately after being marked dirty. This may cause the graph to
update more frequently.

Within the compute graph, data can be updated in-place by using cached values.
This makes it impossible for the compute graph to know whether that data has
changed as the old data is not available anymore. In these cases updates are
always propagated and observables are always triggered. If the observable is
used to (eventually) update an input of the node it represents, this could lead
to infinite loops of equal updates. To prevent these, the data in the Observable
is a `deepcopy` of the data in the compute node and their data is compared
before updating.
Setting `use_deepcopy = false` will turn this safeguard off, removing both the
deepcopy and the equality check. In this case in-place updates of the node will
always trigger observable updates. Any other duplicate updates will be skipped.
"""
function get_observable!(attr::ComputeGraph, key::Symbol; use_deepcopy = true)
    # Because we allow output arrays to be reused it can be impossible to tell
    # if the data has updated. In this case the data is marked as dirty/changed
    # and added to the `onchange`. If this data is fed into an Observable which
    # updates the graph it can lead to infinite loops.
    # To prevent this we have to disambiguate the data and do == checks here.
    # This requires us to copy data every time we update and we can't use
    # `copy` because that is not always available (e.g. not for Rect)
    return get!(attr.observables, key) do
        if use_deepcopy
            push!(attr.should_deepcopy, key)
        end
        # resolve first so eltype can work
        val = attr.outputs[key]
        initial_value = use_deepcopy ? deepcopy(val[]) : val[]
        # The graph already does ignore_equal_values = true checks when data is
        # not updated in-place, so it's useless to add it here
        return Observable{eltype(val.value)}(initial_value)
    end
end

function get_observable!(c::Computed; use_deepcopy = true)
    if hasparent(c)
        p = getparent(c)
        return get_observable!(p.graph, c.name; use_deepcopy = use_deepcopy)
    else
        error("Cannot get observable for Computed without parent")
    end
end

function Observables.on(f, x::Computed; kwargs...)
    obs = get_observable!(x)
    return on(f, obs; kwargs...)
end

function Observables.onany(f, arg1::Computed, args::Union{Observable, Computed}...; kwargs...)
    obsies = map(x -> x isa Computed ? get_observable!(x) : x, (arg1, args...))
    @assert all(obs -> obs isa Observable, obsies) "Failed to create Observables for all entries"
    return onany(f, obsies...; kwargs...)
end
function Observables.map!(f, target::Observable, args::Computed...; kwargs...)
    obsies = map(x -> x isa Computed ? get_observable!(x) : x, args)
    return map!(f, target, obsies...; kwargs...)
end
function Observables.map(f, arg1::Computed, args...; kwargs...)
    obsies = map(x -> x isa Computed ? get_observable!(x) : x, (arg1, args...))
    return map(f, obsies...; kwargs...)
end


# ComputeEdge(f) = ComputeEdge(f, Computed[])
function ComputeEdge(f, graph::ComputeGraph, inputs::Vector{Computed})
    return ComputeEdge{ComputeGraph}(
        graph, f, inputs, fill(true, length(inputs)), Computed[], RefValue(false),
        ComputeEdge[], RefValue{TypedEdge}()
    )
end

function ComputeGraph()
    graph = ComputeGraph(
        Dict{Symbol, ComputeEdge}(), Dict{Symbol, Computed}(), Base.ReentrantLock(),
        Observable(Set{Symbol}()), Dict{Symbol, Observable}(), Set{Symbol}(),
        Observables.ObserverFunction[], Observable[]
    )

    on(graph.onchange) do changeset
        intersect!(changeset, keys(graph.observables))

        # update data
        for key in changeset
            val = graph.outputs[key][]
            obs = graph.observables[key]
            # Trust the graph to discard equal values. This doesn't work for
            # anything updated in-place
            if !(key in graph.should_deepcopy)
                obs.val = val
            elseif !isequal(val, obs[]) # treat in-place updates (use isequal to handle NaN correctly)

                obs.val = deepcopy(val)
            else # same value (with deepcopy), skip update
                delete!(changeset, key)
            end
        end

        # trigger observables
        for key in changeset
            notify(graph.observables[key])
        end

        # clear changeset after processing observables
        empty!(changeset)
        return Consume(false)
    end

    return graph
end

_first_arg(args, changed, last) = (args[1],)

"""
    alias!(graph::ComputeGraph, input::Symbol, output::Symbol)

Creates `output` as an alias of `input`.
"""
function alias!(attr::ComputeGraph, key::Symbol, alias_key::Symbol)
    # TODO: more efficient implementation!
    register_computation!(_first_arg, attr, [key], [alias_key])
    return attr
end

function isdirty(computed::Computed)
    return hasparent(computed) && isdirty(computed.parent)
end


isdirty(edge::ComputeEdge) = !edge.got_resolved[]

# Note:
# GLMakie may mark an unresolved renderobject as resolved to avoid repeated
# errors from repeatedly pulling it. This requires us to not shortcut mark_dirty!()
# Without that, we should be able to skip mark_dirty for any child/dependent that
# is already dirty

"""
    mark_resolved!(computed)

Mark the parent edge of a compute node as resolved, so that the node will no
longer try to update. This will be undone the next time any (recursive) input
to the node is updated.
"""
function mark_resolved!(computed::Computed)
    hasparent(computed) && mark_resolved!(computed.parent)
    return
end
mark_resolved!(edge::ComputeEdge) = edge.got_resolved[] = true
mark_resolved!(edge::Input) = edge.is_dirty = true

function mark_dirty!(edge::ComputeEdge, obs_to_update::Vector{Observable})
    # Assumes this is the same graph as edge.outputs (for parent -> child graph edges)
    g = edge.graph
    for output in edge.outputs
        push!(g.onchange.val, output.name)
        g.onchange in obs_to_update || push!(obs_to_update, g.onchange)
    end

    edge.got_resolved[] = false
    for dep in edge.dependents
        mark_dirty!(dep, obs_to_update)
    end
    return
end

function mark_dirty!(computed::Computed)
    computed.dirty = true
    hasparent(computed) || return
    return mark_dirty!(computed.parent)
end

function resolve!(input::Input)
    input.dirty || return
    value = input.f(input.value)
    if isdefined(input.output, :value) && isassigned(input.output.value)
        input.output.value[] = deref(value)
    else
        input.output.value = value isa RefValue ? value : RefValue(value)
    end
    input.dirty = false
    input.output.dirty = true
    for edge in input.dependents
        mark_input_dirty!(input, edge)
    end
    input.output.dirty = false
    return input.output.value[]
end

function mark_dirty!(input::Input, obs_to_update::Vector{Observable})
    push!(input.graph.onchange.val, input.name)
    if !(input.graph.onchange in obs_to_update)
        push!(obs_to_update, input.graph.onchange)
    end

    input.dirty = true
    for edge in input.dependents
        mark_dirty!(edge, obs_to_update)
    end
    return
end

mark_dirty!(x) = mark_dirty!(x, x.graph.obs_to_update)

update_observables!(comp::Computed) = update_observables!(comp.parent)
update_observables!(edge::Input) = update_observables!(edge.graph)
update_observables!(edge::ComputeEdge) = update_observables!(edge.graph)
update_observables!(graph::ComputeGraph) = update_observables!(graph.obs_to_update)
function update_observables!(obs_to_update::Vector{Observable})
    foreach(notify, obs_to_update)
    empty!(obs_to_update)
    return
end

function Base.setindex!(computed::Computed, value)
    if computed.parent isa Input
        return setindex!(computed.parent, value)
    else
        computed.value[] = value
        mark_dirty!(computed)
        update_observables!(computed)
        return value
    end
end

function Base.setindex!(input::Input, value)
    if is_same(input.value, value)
        # Skip if the value is the same as before
        return value
    end
    input.value = value
    mark_dirty!(input)
    update_observables!(input)
    return value
end

function _setproperty!(attr::ComputeGraph, key::Symbol, value)
    input = attr.inputs[key]
    # Skip if the value is the same as before
    is_same(input.value, value) && return value
    # can't notify observables immediately here, because update may call this
    # multiple times for a synchronized update (would cause desync)
    mark_dirty!(input)
    input.value = value
    return value
end

function Base.setproperty!(attr::ComputeGraph, key::Symbol, value)
    return lock(attr.lock) do
        _setproperty!(attr, key, value)
        foreach(notify, attr.obs_to_update)
        return value
    end
end

"""
    update!(graph; kwargs...)
    update!(graph, pairs::Pair{Symbol, Any}...)

Updates any number of inputs in the graph based on the passed `key = value`
keyword arguments. The `key` refers to the name of the input and the `value` is
the new value.

## Example:

```
graph = ComputeGraph()
add_input!(graph, :first_node, 1)
update!(graph, first_node = 2)
update!(graph, :first_node => 2)
```
"""
update!(attr::ComputeGraph; kwargs...) = update!(attr, [Pair{Symbol, Any}(k, v) for (k, v) in kwargs])
update!(attr::ComputeGraph, dict::Dict{Symbol}) = _update!(attr, dict)
update!(attr::ComputeGraph, pairs::Pair{Symbol}...) = _update!(attr, [Pair{Symbol, Any}(k, v) for (k, v) in pairs])
update!(attr::ComputeGraph, pairs::AbstractVector{<:Pair{Symbol}}) = _update!(attr, pairs)

function _update!(attr::ComputeGraph, values)
    return lock(attr.lock) do
        for (key, value) in values
            if haskey(attr.inputs, key)
                _setproperty!(attr, key, value)
            else
                error("Attribute $key not found in ComputeGraph")
            end
        end
        update_observables!(attr)
        return attr
    end
end

Base.haskey(attr::ComputeGraph, key::Symbol) = haskey(attr.outputs, key)
Base.get(attr::ComputeGraph, key::Symbol, default) = get(attr.outputs, key, default)

function Base.getproperty(attr::ComputeGraph, key::Symbol)
    # more efficient to hardcode?
    key === :inputs && return getfield(attr, :inputs)
    key === :outputs && return getfield(attr, :outputs)
    key === :onchange && return getfield(attr, :onchange)
    key === :observables && return getfield(attr, :observables)
    key === :observerfunctions && return getfield(attr, :observerfunctions)
    key === :obs_to_update && return getfield(attr, :obs_to_update)
    key === :lock && return getfield(attr, :lock)
    key === :should_deepcopy && return getfield(attr, :should_deepcopy)
    return attr.outputs[key]
end

function Base.getindex(attr::ComputeGraph, key::Symbol)
    return attr.outputs[key]
end
isdirty(input::Input) = input.dirty

Base.getindex(computed::Computed) = resolve!(computed)

function mark_input_dirty!(parent::ComputeEdge, edge::ComputeEdge)
    @assert parent.got_resolved[] # parent should only call this after resolve!
    for i in eachindex(edge.inputs)
        edge.inputs_dirty[i] |= getfield(edge.inputs[i], :dirty)
    end
    return
end

function mark_input_dirty!(parent::Input, edge::ComputeEdge)
    @assert !parent.dirty # should got resolved
    for i in eachindex(edge.inputs)
        edge.inputs_dirty[i] |= getfield(edge.inputs[i], :dirty)
    end
    return
end

function set_result!(edge::TypedEdge, result, i, value)
    if isnothing(value) || is_same(edge.outputs[i][], value)
        edge.output_nodes[i].dirty = false
    else
        edge.output_nodes[i].dirty = true
        edge.outputs[i][] = deref(value)
    end
    if !isempty(result)
        next_val = first(result)
        rem = Base.tail(result)
        set_result!(edge, rem, i + 1, next_val)
    end
    return
end

function set_result!(edge::TypedEdge, result)
    next_val = first(result)
    rem = Base.tail(result)
    return set_result!(edge, rem, 1, next_val)
end

is_same(@nospecialize(a), @nospecialize(b)) = false
is_same(a::Symbol, b::Symbol) = a == b
function is_same(a::T, b::T) where {T}
    if isbitstype(T)
        # We can compare immutable isbits type per value with `===`
        return a === b
    else
        # For mutable types, we can only compare them if they're not pointing to the same  object
        # If they are the same, we have to give up since we can't test if they got mutated in-between
        # Otherwise we can compare by equivalence
        same_object = a === b
        return same_object ? false : isequal(a, b)
    end
end
function is_same(old::Array, new::Array)
    # same pointer means memory aliased (which does not require old === new)
    # and same memory means we can't compare before and after => assume not same
    is_distinct = pointer(old) !== pointer(new)
    return is_distinct && isequal(old, new)
end

# do we want this type stable?
# This is how we could get a type stable callback body for resolve
function resolve!(edge::TypedEdge)
    if any(edge.inputs_dirty) # only call if inputs changed
        dirty = _get_named_change(edge.inputs, edge.inputs_dirty)
        vals = map(getindex, edge.outputs)
        names = ntuple(length(vals)) do i
            edge.output_nodes[i].name
        end
        last = NamedTuple{names}(vals)
        result = edge.callback(map(getindex, edge.inputs), dirty, last)
        if result isa Tuple
            if length(result) != length(edge.outputs)
                error("Did not return correct length: $(result), $(edge.callback)")
            end
            set_result!(edge, result)
        elseif isnothing(result)
            foreach(x -> x.dirty = false, edge.output_nodes)
        else
            error("Needs to return a Tuple with one element per output, or nothing")
        end
    end
    return
end

function resolve!(computed::Computed)
    try
        return _resolve!(computed)
    catch e
        rethrow(ResolveException(computed, e))
    end
end

function _resolve!(computed::Computed)
    if hasparent(computed)
        resolve!(computed.parent)
    end
    return computed.value[]
end

function resolve!(edge::ComputeEdge)
    isdirty(edge) || return false
    return lock(edge.graph.lock) do
        # Resolve inputs first
        foreach(_resolve!, edge.inputs)
        if !isassigned(edge.typed_edge)
            # constructor does first resolve to determine fully typed outputs
            edge.typed_edge[] = TypedEdge(edge)
        else
            resolve!(edge.typed_edge[])
        end
        edge.got_resolved[] = true
        fill!(edge.inputs_dirty, false)
        for dep in edge.dependents
            mark_input_dirty!(edge, dep)
        end
        foreach(comp -> comp.dirty = false, edge.outputs)
        return true
    end
end


"""
    add_input!([callback], compute_graph, name::Symbol, value)

Adds a new input to the given `compute_graph`. The input is referred to by the
given `name` and is initialized with the given `value`. If a `callback` is given
any new value will be passed to `callback(name, new_value)` before being stored
in the compute graph.

## Example:

```
graph = ComputeGraph()

add_input!(graph, :first_node, 1)
add_input!((k, v) -> Float32(v), graph, :second_node, 2)
```
"""
add_input!(attr::ComputeGraph, key::Symbol, value) = _add_input!(identity, attr, key, value)

# For cleaner printing and error tracking we do not use an anonymous function
#   value -> conversion_function(key, value)
# or
#   (value,), changed, cached -> conversion_function(key, value)
# but instead create an explicit wrapper here.
struct InputFunctionWrapper{FT} <: Function
    key::Symbol
    user_func::FT
end
(x::InputFunctionWrapper)(v) = x.user_func(x.key, v)
(x::InputFunctionWrapper)(inputs, changed, cached) = (x.user_func(x.key, inputs[1]),)

function add_input!(conversion_func, attr::ComputeGraph, key::Symbol, value)
    return _add_input!(InputFunctionWrapper(key, conversion_func), attr, key, value)
end

function _add_input!(func, attr::ComputeGraph, key::Symbol, value)
    @assert !(value isa Computed)
    if haskey(attr.inputs, key) || haskey(attr.outputs, key)
        error("Cannot attach input with name $key - already exists!")
    end

    output = Computed(key)
    input = Input(attr, key, value, func, output)
    output.parent = input
    output.parent_idx = 1
    # Needs to be Any, since input can change type
    attr.inputs[key] = input
    attr.outputs[key] = output
    return attr
end

function add_inputs!(conversion_func, attr::ComputeGraph; kw...)
    for (k, v) in pairs(kw)
        add_input!(conversion_func, attr, k, v)
    end
    return attr
end

compute_identity(inputs, changed, cached) = values(inputs)

function TypedEdge(edge::ComputeEdge, f::typeof(compute_identity), inputs)
    if length(inputs) != length(edge.outputs)
        error("A `compute_identity` callback requires the length of inputs and outputs to match.")
    end

    # use input refs as output refs so we don't even need to evaluate the callback
    for i in eachindex(values(inputs))
        edge.outputs[i].value = inputs[i]
        edge.outputs[i].dirty = true
    end

    return TypedEdge(f, inputs, edge.inputs_dirty, inputs, edge.outputs)
end

function resolve!(edge::TypedEdge{IT, OT, typeof(compute_identity)}) where {IT, OT}
    # outputs are identical to inputs, so just copy the input state. To be safe
    # don't overwrite any `dirty = true` state with false (maybe a problem if
    # the input gets resolved?)
    for i in eachindex(edge.inputs_dirty)
        edge.output_nodes[i].dirty |= edge.inputs_dirty[i]
    end
    return
end

"""
    add_input!([callback], compute_graph, name::Symbol, node::Computed)

Connects an output `node` of another compute graph to the given `compute_graph`.

This does not create a settable input, meaning you cannot use
`update!(graph, name = new_value)` to update it. It is solely updated by the
connected node.
"""
function add_input!(attr::ComputeGraph, key::Symbol, value::Computed)
    if haskey(attr.outputs, key)
        error("Cannot attach throughput with name $key - already exists!")
    end
    register_computation!(compute_identity, attr, [value], [key])
    return attr
end

# for recipe -> primitive (mostly)
function add_input!(conversion_func, attr::ComputeGraph, key::Symbol, value::Computed)
    if haskey(attr.outputs, key)
        error("Cannot attach throughput with name $key - already exists!")
    end
    register_computation!(InputFunctionWrapper(key, conversion_func), attr, [value], [key])
    return attr
end

"""
    add_input!([callback], compute_graph, name::Symbol, obs::Observable)

Connects an `Observable` as a input to the given `compute_graph`. The input will
be updated automatically whenever the observable updates. It can also be updated
through the usual `update!(graph, name = new_value)` call.

The Observable listener is set up with `priority = typemax(Int)-1` and
`Consume(false)`. This means it will take precedence over all but `typemax(Int)`
priority and not block later updates.
"""
function add_input!(attr::ComputeGraph, k::Symbol, obs::Observable)
    add_input!(attr, k, obs[])
    # typemax-1 so it doesn't get disturbed by other listeners but can still be
    # blocked by a typemax obs
    # Setting it to lower priority, axis and colorbar don't get the latest update
    # Still need to investigate why exactly
    of = on(obs; priority = typemax(Int) - 1) do new_val
        setproperty!(attr, k, new_val)
        return Consume(false)
    end
    push!(attr.observerfunctions, of)
    return attr
end

function add_input!(f, attr::ComputeGraph, k::Symbol, obs::Observable)
    add_input!(f, attr, k, obs[])
    of = on(obs, priority = typemax(Int) - 1) do new_val
        setproperty!(attr, k, new_val)
        return Consume(false)
    end
    push!(attr.observerfunctions, of)
    return attr
end

"""
    add_constant!(graph, name::Symbol, value)

Adds a constant to the Graph. A constant is not connected to an `Input` and thus
can't change through compute graph resolution.
"""
function add_constant!(attr::ComputeGraph, k::Symbol, value)
    haskey(attr, k) && return
    map!(() -> value, attr, Symbol[], k)
    return attr
end

function add_constants!(attr::ComputeGraph; kw...)
    for (k, v) in pairs(kw)
        add_constant!(attr, k, v)
    end
    return attr
end

get_callback(computed::Computed) = hasparent(computed) ? computed.parent.callback : nothing

"""
    register_computation!(callback, compute_graph, input_names, output_names)

Registers a new computation which transforms the given inputs to a new set of
outputs. Both the inputs and outputs are referred to by name. The inputs must
exist when the function is called. The outputs should usually created by this
function.

The callback function must accept 3 arguments:
- `inputs::NamedTuple` which contains the `input_names` and input values in the order given to `register_computation`
- `changed::NamedTuple` which a `Bool` per input name signifying whether the input has been updated since the last execution of `callback`
- `cached::Tuple` which contain the last outputs returned by function. If no previous outputs exist `cached = nothing`.

Note that `inputs` and `cached` always wrap input and outputs values in `Ref`,
so you need to always dereference them.

## Example:

```julia
graph = ComputeGraph()
add_input!(graph, :input1, 1)
add_input!(graph, :input2, 1)

register_computation!(graph, [:input1, :input2], [:output1, :output2]) do inputs, changed, cached
    input1, input2 = inputs
    has_input1_changed, has_input2_changed2 = changed
    cached_output1, cached_output2 = cached

    # compute new outputs

    return (new_output1, new_output2)
end
```

See also: [`add_input!`](@ref), [`map!`](@ref)
"""
function register_computation!(f, attr::ComputeGraph, inputs::Vector{Symbol}, outputs::Vector{Symbol})
    if !all(k -> haskey(attr.outputs, k), inputs)
        missing_keys = filter(k -> !haskey(attr.outputs, k), inputs)
        error("Could not register computation: Inputs $missing_keys not found.")
    end
    _inputs = Computed[attr.outputs[k] for k in inputs]
    register_computation!(f, attr, _inputs, outputs)
    return
end

# [computed, symbol] is an Any Vector so no eltype here
function register_computation!(f, attr::ComputeGraph, inputs::Vector, outputs::Vector{Symbol})
    _inputs = Computed[k isa Symbol ? attr.outputs[k] : k for k in inputs]
    register_computation!(f, attr, _inputs, outputs)
    return
end

function check_boxed_values(f)
    names = propertynames(f)
    name_values = map(x -> x => getfield(f, x), names)
    boxed = filter(p -> p[2] isa Core.Box, name_values)
    return if !isempty(boxed)
        boxed_str = map(boxed) do (k, v)
            box = isdefined(v, :contents) ? typeof(v.contents) : "#undef"
            return "$(k)::Core.Box($(box))"
        end
        error("Cannot register computation: Callback function cannot use boxed values: $(first(methods(f))), $(join(boxed_str, ",")). This might be caused by a variable of the same name existing inside and outside a `do ... end` block.")
    end
end

macro ifelse_enabled(enabled_expr, disabled_expr = :())
    if ENABLE_COMPUTE_CHECKS
        return esc(enabled_expr)
    else
        return esc(disabled_expr)
    end
end

function assert_same_computation(@nospecialize(f), attr::ComputeGraph, inputs, outputs)
    # Check this so we can type assert later
    if any(k -> haskey(attr.inputs, k), outputs)
        input_nodes = [k for k in outputs if haskey(attr.inputs, k)]
        error("One or multiple edge outputs already exist as graph inputs: $input_nodes")
    end

    e = attr.outputs[outputs[1]].parent::ComputeEdge

    # Check that the edge is shared
    if any(k -> attr.outputs[k].parent::ComputeEdge !== e, outputs)
        # bad_keys = join([k for k in outputs if attr.outputs[k].parent != e], ", ")
        error("Cannot register computation: $outputs already have multiple different parent compute edges.")
    end

    # Check that the requested inputs are the inputs of the new edge
    if length(e.inputs) != length(inputs) || e.inputs != inputs
        error(
            "Cannot register computation: Outputs already have a parent compute edge with different inputs.\n" *
                "   New: (" * join([n.name for n in inputs], ", ") * ") -> (" * join(outputs, ", ") * ")\n" *
                "   Old: (" * join([n.name for n in e.inputs], ", ") * ") -> (" * join([n.name for n in e.outputs], ", ") * ")"
        )
    end

    # Check that the same callback is used
    # TODO: === is much faster, but why?
    if @ifelse_enabled(e.callback != f, e.callback !== f)
        # We should only care about input arg types...
        func1, loc1 = edge_callback_to_string(f, (NamedTuple, NamedTuple, Nothing))
        func2, loc2 = edge_callback_to_string(e)
        error(
            "Cannot register computation: The outputs already have a parent compute edge using " *
                "a different callback function.\n  Given: $func1 $loc1\n  Found: $func2 $loc2\n  $(methods(f))"
        )
    end

    # edge already exists so we can
    return
end

function register_computation!(f, attr::ComputeGraph, inputs::Vector{Computed}, outputs::Vector{Symbol})
    @ifelse_enabled(check_boxed_values(f))

    if any(k -> haskey(attr.outputs, k), outputs)
        N_existing = count(k -> haskey(attr.outputs, k) && hasparent(attr.outputs[k]), outputs)
        if N_existing == 0
            # fine, we won't be overwriting an edge
        elseif N_existing != length(outputs)
            existing = [k for k in outputs if haskey(attr.outputs, k) && hasparent(attr.outputs[k])]
            combined = join(existing, ", ")
            error("Cannot register computation: Some outputs already have parent compute edges: $combined")
        else

            assert_same_computation(f, attr, inputs, outputs)

            # edge already exists so we can return
            return
        end
    end

    new_edge = ComputeEdge(f, attr, inputs)

    for input in inputs
        @assert hasparent(input) "Computed should be guaranteed to have a parent edge, but does not"
        # Edges can have multiple outputs so multiple inputs of this edge could
        # come from the same edge
        any(x -> x === new_edge, input.parent.dependents) && continue
        push!(input.parent.dependents, new_edge)
    end

    # use order of namedtuple, which should not change!
    for (i, symbol) in enumerate(outputs)
        # create an uninitialized Ref, which gets replaced by the correctly strictly typed Ref on first resolve
        value = get!(attr.outputs, symbol, Computed(symbol))
        value.parent = new_edge
        value.parent_idx = i
        value.dirty = true
        push!(new_edge.outputs, value)
    end

    return
end

struct MapFunctionWrapper{pack, FT} <: Function
    user_func::FT
    MapFunctionWrapper(f::FT, pack = true) where {FT} = new{pack, FT}(f)
end

function (x::MapFunctionWrapper{true})(inputs, @nospecialize(changed), @nospecialize(cached))
    result = x.user_func(values(inputs)...)
    return (result,)
end
function (x::MapFunctionWrapper{false})(inputs, @nospecialize(changed), @nospecialize(cached))
    result = x.user_func(values(inputs)...)
    return result
end

"""
    map!(f, compute_graph::ComputeGraph, inputs::Union{Symbol, Computed, Vector}, outputs::Union{Symbol, Vector{Symbol}}; init=nothing)

Registers a new ComputeEdge in the `compute_graph` which connect one or multiple
`inputs` to one or multiple `outputs`.

Inputs can be Symbols referring to compute nodes in `compute_graph`, or compute
nodes from any graph. These can also be mixed. Outputs are always Symbols naming
the new nodes generated by this function.

The callback function `f` will be called with the values of the inputs as arguments.
If the output is a `::Symbol`, the function is expected to return a value, otherwise
it is expected to return a tuple of values to be mapped to the outputs.

## Arguments
- `init=nothing`: Optional initial value(s) for the output node(s). For a single output,
  provide the value directly. For multiple outputs, provide a tuple matching the number
  of outputs. This allows the outputs to have a value before the computation runs.

```julia
graph = ComputeGraph()
add_input!(graph, :input1, 2)
add_input!(graph, :input2, 1)

other_graph = ComputeGraph()
add_input!(other_graph, :input, 3)

map!(x -> 2x, graph, :input1, :output1)
map!((x, y) -> x+y, graph, [:input1, other_graph.input], :output2)
map!((x, y) -> (x+y, x-y), graph, [:input1, :input2], [:output3, :output4])

# With initial values
map!(x -> 2x, graph, :input1, :output5; init=0)
map!((x, y) -> (x+y, x-y), graph, [:input1, :input2], [:output6, :output7]; init=(0, 0))
```

See also: [`add_input!`](@ref), [`register_computation!`](@ref)
"""
function Base.map!(f, attr::ComputeGraph, input::Union{Symbol, Computed}, output::Symbol; init = nothing)
    register_computation!(MapFunctionWrapper(f), attr, [input], [output])
    if !isnothing(init)
        unsafe_init!(attr.outputs[output], init)
    end
    return attr
end

function Base.map!(f, attr::ComputeGraph, inputs::Vector, output::Symbol; init = nothing)
    register_computation!(MapFunctionWrapper(f), attr, inputs, [output])
    if !isnothing(init)
        unsafe_init!(attr.outputs[output], init)
    end
    return attr
end

function Base.map!(f, attr::ComputeGraph, inputs::Vector, outputs::Vector{Symbol}; init = nothing)
    register_computation!(MapFunctionWrapper(f, false), attr, inputs, outputs)
    if !isnothing(init)
        @assert init isa Tuple && length(init) == length(outputs) "Initial values for map! must be given as a Tuple matching the number of outputs"
        for (i, val) in enumerate(init)
            unsafe_init!(attr.outputs[outputs[i]], val)
        end
    end
    return attr
end

function Base.map!(f, attr::ComputeGraph, inputs::Union{Symbol, Computed}, outputs::Vector{Symbol}; init = nothing)
    register_computation!(MapFunctionWrapper(f, false), attr, [inputs], outputs)
    if !isnothing(init)
        @assert init isa Tuple && length(init) == length(outputs) "Initial values for map! must be given as a Tuple matching the number of outputs"
        for (i, val) in enumerate(init)
            unsafe_init!(attr.outputs[outputs[i]], val)
        end
    end
    return attr
end

function take_last!(channel::Channel; wait = false)
    return lock(channel) do
        result = wait ? take!(channel) : nothing
        while isready(channel)
            result = take!(channel)
        end
        return result
    end
end

"""
    map_latest!(f, compute_graph::ComputeGraph, inputs::Vector{Symbol}, outputs::Vector{Symbol}; spawn=false, init=nothing)

Registers an asynchronous computation in the `compute_graph` that processes only the
most recent input changes, skipping intermediate updates if the computation is still running.

This is useful for expensive computations where intermediate results are not needed, such as:
- Heavy image processing or rendering operations
- Slow network requests
- Complex data analysis or simulations

## Behavior

When inputs change:
- any new value is put in a queue to be computed
- If multiple updates occur while computing, only the **most recent** input values are
  kept; intermediate values are discarded
- The outputs return cached values while the computation is in progress
- finishing a computation invalidates the graph, so on the next poll the latest result is returned

The first call to retrieve outputs will block until the initial computation completes,
unless `init` is provided.

## Arguments
- `f`: Callback function that receives input values as individual arguments and returns
  a tuple of output values
- `compute_graph`: The compute graph to register the computation in
- `inputs`: Vector of Symbol names referring to input nodes in the graph
- `outputs`: Vector of Symbol names for the output nodes to be created
- `spawn=false`: If `true`, runs the background worker on a separate thread. If `false`,
  runs an async task.
- `init=nothing`: Optional tuple of initial values for the output nodes. Must match the
  number of outputs. This allows the outputs to have a value before the first computation
  completes.

## Example

```julia
graph = ComputeGraph()
add_input!(graph, :image_data, initial_image)
add_input!(graph, :filter_strength, 1.0)

# Register expensive async computation that skips intermediate updates
map_latest!(graph, [:image_data, :filter_strength], [:filtered_image]) do img, strength
    # This expensive operation only runs on the latest inputs
    result = expensive_filter(img, strength)
    return (result,)
end

# Rapidly update inputs - only the final values will be processed
for i in 1:100
    update!(graph, filter_strength = i / 10.0)
end
graph[:filtered_image][] # poll to trigger computation queue
sleep(0.1) # wait for a computation to finish to not get old result
result = graph[:filtered_image][]
```
"""
function map_latest!(f, attr::ComputeGraph, inputs::Vector{Symbol}, outputs::Vector{Symbol}; spawn = false, init = nothing)
    update_key = Symbol(:_update_trigger_, string(hash((inputs, outputs))))
    add_input!(attr, update_key, time())
    # TODO, should both channels be size 1?
    # Channel for input requests
    input_channel = Channel{Any}(2)
    # Background worker task that processes computation requests
    result_channel = Channel(2; spawn = spawn) do result_channel
        while isopen(input_channel)
            try
                # Take the first item (blocking if empty)
                fetched_inputs = take_last!(input_channel; wait = true)
                # Process the most recent inputs
                result = f(fetched_inputs...)
                # Put result in the result channel
                put!(result_channel, result)
                # Notify that we got a new value, for the below computation to run
                update!(attr, update_key => time())
            catch e
                @error "Error in background computation task" exception = (e, catch_backtrace())
            end
        end
    end
    register_computation!(attr, [update_key, inputs...], outputs) do inputs, changed, last
        user_inputs = tail(values(inputs))
        # Blocking wait for first result, this can't be avoided, since the node needs to be initialized
        isnothing(last) && return f(user_inputs...)
        # Always queue new computation unless no user inputs changed
        if any(tail(values(changed)))
            take_last!(input_channel) # discard old inputs
            put!(input_channel, user_inputs)
        end
        # Always return the last result
        # if there is non, this returns nothing, which signals no update
        return take_last!(result_channel)
    end
    if !isnothing(init)
        @assert init isa Tuple && length(init) == length(outputs) "Initial values for map_latest! must be given as a Tuple matching the number of outputs"
        for (i, val) in enumerate(init)
            unsafe_init!(attr.outputs[outputs[i]], val)
        end
    end
    return
end


function Base.empty!(attr::ComputeGraph)
    # empty!(attr.inputs)
    # empty!(attr.outputs)
    for (name, obs) in attr.observables
        Observables.clear(obs)
    end
    empty!(attr.observables)
    for of in attr.observerfunctions
        Observables.off(of)
    end
    return empty!(attr.observerfunctions)
end

"""
    delete!(graph::ComputeGraph, key::Symbol[; force = false, recursive = false])

Deletes a node from the given graph based on its name.

If `recursive = true` all child nodes of the selected node are deleted. If
`force = true` all siblings (outputs from the same parent edge) are deleted.
If either exists without the respective option being true an error will be thrown.
"""
function Base.delete!(attr::ComputeGraph, key::Symbol; force::Bool = false, recursive::Bool = false)
    return lock(attr.lock) do
        haskey(attr.outputs, key) || throw(KeyError(key))
        _delete!(attr, attr.outputs[key], force, recursive)
        return attr
    end
end

function _delete!(attr::ComputeGraph, node::Computed, force::Bool, recursive::Bool)
    @assert hasparent(node)
    _delete!(attr, node.parent, force, recursive)
    return attr
end

function validate_deletion(edge::ComputeEdge, force::Bool, recursive::Bool)
    force && recursive && return
    if !(length(edge.outputs) == 1 || force)
        error("Cannot delete node because it or one of its dependents has siblings. Set `force = true` to also delete siblings.")
    end
    if !(recursive || isempty(edge.dependents))
        error("Cannot delete node because it has children. Set `recursive = true` to also delete its children.")
    end
    return foreach(e -> validate_deletion(e, force, recursive), edge.dependents)
end

function validate_deletion(edge::Input, force::Bool, recursive::Bool)
    force && recursive && return
    if !(recursive || isempty(edge.dependents))
        error("Cannot delete node because it has children. Set `recursive = true` to also delete its children.")
    end
    return foreach(e -> validate_deletion(e, force, recursive), edge.dependents)
end

function _delete!(attr::ComputeGraph, edge::AbstractEdge, force::Bool, recursive::Bool)
    validate_deletion(edge, force, recursive)
    return unsafe_delete!(attr, edge)
end

function unsafe_delete!(attr::ComputeGraph, edge::ComputeEdge)
    # all dependents become invalid as their parent computation no longer runs
    for dependent in edge.dependents
        unsafe_delete!(attr, dependent)
    end

    # deregister this edge as a dependency of its parents
    for computed in edge.inputs
        @assert hasparent(computed)
        parent_edge = computed.parent
        filter!(e -> e !== edge, parent_edge.dependents)
    end

    # Delete output nodes of this edge
    for computed in edge.outputs
        k = computed.name
        @assert haskey(attr.outputs, k) && attr.outputs[k] === computed
        delete!(attr.outputs, k)
    end

    return attr
end

function unsafe_delete!(attr::ComputeGraph, edge::Input)
    # all dependents become invalid as their parent computation no longer runs
    for dependent in edge.dependents
        unsafe_delete!(attr, dependent)
    end

    # Delete output node of this edge
    k = edge.name
    @assert haskey(attr.outputs, k) && attr.outputs[k] === edge.output
    delete!(attr.outputs, k)

    # Delete Input
    @assert haskey(attr.inputs, k) && attr.inputs[k] === edge
    delete!(attr.inputs, k)

    return attr
end

"""
    unsafe_disconnect_parents!(graph)

Removes every reference to this graph from every connected parent graph. This is
meant to prepare the given graph for garbage collection.

After calling this function, the graph will be in a broken state. Edges
connecting this graph to parent graphs still exist with references to parent
graphs, but they can no longer be triggered.
"""
function unsafe_disconnect_from_parents!(attr::ComputeGraph)
    for comp in values(attr.outputs)
        if hasparent(comp)
            unsafe_disconnect_parent_graph_nodes!(attr, comp.parent)
        end
    end
    return
end

unsafe_disconnect_parent_graph_nodes!(attr::ComputeGraph, edge::Input) = nothing
function unsafe_disconnect_parent_graph_nodes!(attr::ComputeGraph, edge::ComputeEdge)
    for input in edge.inputs
        if !haskey(attr.outputs, input.name) || !(input in values(attr.outputs))
            unsafe_atomic_delete!(edge)
        end
    end
    return
end

function unsafe_atomic_delete!(edge::ComputeEdge)
    # deregister this edge as a dependency of its parents
    for computed in edge.inputs
        if hasparent(computed)
            parent_edge = computed.parent
            filter!(e -> e !== edge, parent_edge.dependents)
        end
    end

    return
end


is_initialized(node::Computed) = isdefined(node, :value) && isassigned(node.value)

"""
    unsafe_init!(node::Computed, value)

Initializes a node to the given value. If this causes all outputs of the parent
compute edge to be initialized, the edge will be initialized without calling its
callback.

This function makes no checks to confirm that the given value matches the type
returned by the parent edge callback.
"""
function unsafe_init!(node::Computed, value)
    if isdefined(node, :value)
        error("Node already initialized.")
    else
        node.value = value isa RefValue ? value : RefValue(value)
    end

    edge = node.parent
    if !all(is_initialized, edge.outputs)
        return false
    end

    return lock(edge.graph.lock) do
        # Resolve inputs first
        foreach(_resolve!, edge.inputs)
        edge.typed_edge[] = TypedEdge_no_call(edge)
        edge.got_resolved[] = true
        fill!(edge.inputs_dirty, false)
        for dep in edge.dependents
            mark_input_dirty!(edge, dep)
        end
        foreach(comp -> comp.dirty = false, edge.outputs)
        return true
    end
end

function TypedEdge_no_call(edge::ComputeEdge)
    inputs = let
        N = length(edge.inputs)
        names = ntuple(i -> edge.inputs[i].name, N)
        values = ntuple(i -> edge.inputs[i].value, N)
        NamedTuple{names}(values)
    end

    outputs = let
        N = length(edge.outputs)
        names = ntuple(i -> edge.outputs[i].name, N)
        values = ntuple(i -> edge.outputs[i].value, N)
        NamedTuple{names}(values)
    end

    return TypedEdge(edge.callback, inputs, edge.inputs_dirty, outputs, edge.outputs)
end

include("io.jl")

export Computed, ComputeEdge
export ComputeGraph
export register_computation!, map_latest!
export add_input!, add_inputs!, add_constant!, add_constants!
export update!

end

function Base.show(io::IO, computed::Computed)
    return if isdefined(computed, :value) && isassigned(computed.value)
        print(IOContext(io, :limit => true), "Computed(:", computed.name, ", ", computed.value[], ")")
    else
        print(io, "Computed(:", computed.name, ", #undef)")
    end
end

function Base.show(io::IO, ::MIME"text/plain", computed::Computed)
    println(io, "Computed:")
    println(io, "  name = :", computed.name)
    if hasparent(computed)
        if computed.parent isa Input
            println(io, "  parent = ", computed.parent)
        else
            println(io, "  parent = ", computed.parent, " @ output ", computed.parent_idx)
        end
    else
        println(io, "parent = #undef")
    end
    v = isdefined(computed, :value) && isassigned(computed.value) ? computed.value[] : "#undef"
    print(io, "  value = ")
    print(IOContext(io, :limit => true), v)
    return print(io, "\n  dirty = ", isdirty(computed))
end


edge_callback_name(f::Function, call = "(…)") = "$(nameof(f))$call"
edge_callback_name(f::InputFunctionWrapper, call = "(…)") = "(::InputFunctionWrapper(:$(f.key), $(nameof(f.user_func))))$call"
edge_callback_name(f::MapFunctionWrapper, call = "(…)") = "(::MapFunctionWrapper($(nameof(f.user_func))))$call"
edge_callback_name(functor, call = "(…)") = "(::$(nameof(functor)))$call"


# This should mirror the inputs and outputs a ComputeEdge callback uses
_get_named_inputs(edge::ComputeEdge) = _get_named_data(edge.inputs, NamedTuple())
_get_named_outputs(edge::ComputeEdge) = _get_named_data(edge.outputs, nothing)
function _get_named_data(collection, fallback)
    if all(c -> isdefined(c, :value) && isassigned(c.value), collection)
        N = length(collection)
        names = ntuple(i -> collection[i].name, N)
        values = ntuple(i -> collection[i].value[], N)
        return NamedTuple{names}(values)
    else
        return fallback
    end
end

# Get the function called by the edge with its input types
# This skips over InputFunctionWrapper to give users more relevant function locations
get_callback_info(edge::Input) = get_callback_info(edge.f, edge.value)
function get_callback_info(edge::ComputeEdge)
    input = _get_named_inputs(edge)
    changed = NamedTuple{keys(input)}(ntuple(x -> true, length(keys(input))))
    output = _get_named_outputs(edge)
    return get_callback_info(edge.callback, input, changed, output)
end

# catch-all for the final user function being called.
# could be:
#   f(inputs, changed, cached) from register_computation!()
#   f(key, input) from InputFunctionWrapper in Input
#   f(input) from MapFunctionWrapper in map!()
# or some other syntax due to a wrapper created in another package
get_callback_info(f, args...) = f, typeof.(args)

# ComputeEdge with InputFunctionWrapper which drops changed and cached
# from add_input!(f, key, ::Computed)
function get_callback_info(f::InputFunctionWrapper, inputs, changed, outputs)
    # if the edge inputs aren't initialized yet we fall back onto am empty namedtuple
    return get_callback_info(f.user_func, f.key, length(inputs) > 0 ? inputs[1] : nothing)
end

# Input with InputFunctionWrapper adding Symbol to the callback
# for add_input!(f, key, value)
function get_callback_info(f::InputFunctionWrapper, input)
    return get_callback_info(f.user_func, f.key, input)
end

# map!(f, attr, ...) call which drops changed, cached and NamedTuple
# for add_input!(f, key, value)
function get_callback_info(f::MapFunctionWrapper, inputs, changed, outputs)
    return get_callback_info(f.user_func, values(inputs))
end

# add_input!(key, value)
get_callback_info(f::typeof(identity), arg) = f, (typeof(arg),)


# Generate a string pointing to the location of the callback function in edge.
# This skips over InputFunctionWrapper and MapFunctionWrapper to give more relevant locations
function edge_callback_location(edge)
    f, arg_types = get_callback_info(edge)
    return edge_callback_location(f, arg_types)
end
function edge_callback_location(f, arg_types::Tuple)
    if hasmethod(f, arg_types)
        file, line = Base.functionloc(f, arg_types)
        return "$file:$line"
    else
        return "unknown method location"
    end
end

# Generate a string with the edges callback function signature and location.
# This skips over InputFunctionWrapper and MapFunctionWrapper to give more relevant locations
function edge_callback_to_string(edge)
    f, arg_types = get_callback_info(edge)
    return edge_callback_to_string(f, arg_types)
end
function edge_callback_to_string(f, arg_types::Tuple)
    arg_str = join(("::$T" for T in arg_types), ", ")
    arg_str = replace(arg_str, "Base.RefValue" => "Ref")
    func = edge_callback_name(f, "($arg_str)")
    loc = edge_callback_location(f, arg_types)
    return "$func", "@ $loc"
end

function Base.show(io::IO, edge::ComputeEdge)
    N1 = length(edge.inputs)
    N2 = length(edge.outputs)
    N3 = length(edge.dependents)
    return print(
        io, "ComputeEdge(",
        edge_callback_name(edge.callback), ", ",
        N1, " input$(N1 == 1 ? "" : 's'), ",
        N2, " output$(N2 == 1 ? "" : 's'), ",
        N3, " dependent$(N3 == 1 ? "" : 's'))"
    )
end

function Base.show(io::IO, ::MIME"text/plain", edge::ComputeEdge)
    println(io, "ComputeEdge:")

    f, loc = edge_callback_to_string(edge)
    println(io, "  callback:\n    $f")
    printstyled(io, "    $loc\n", color = :light_black)

    print(io, "  inputs:")
    for (dirty, v) in zip(edge.inputs_dirty, edge.inputs)
        if dirty
            printstyled(io, "\n    ↻ $v", color = :light_black)
        else
            print(io, "\n    ✓ ", v)
        end
    end

    print(io, "\n  outputs:")
    for v in edge.outputs
        if isdirty(v)
            printstyled(io, "\n    ↻ $v", color = :light_black)
        else
            print(io, "\n    ✓ ", v)
        end
    end

    print(io, "\n  dependents:")
    for v in edge.dependents
        if isdirty(v)
            printstyled(io, "\n    ↻ $v", color = :light_black)
        else
            print(io, "\n    ✓ ", v)
        end
    end
    return
end


function Base.show(io::IO, input::Input)
    return print(io, "Input(:", input.name, ", ", input.value, ")")
end

function Base.show(io::IO, ::MIME"text/plain", input::Input)
    println(io, "Input:")
    println(io, "  name:     :", input.name)
    println(io, "  value:    ", input.value)
    f, loc = edge_callback_to_string(input)
    print(io, "  callback: $f")
    printstyled(io, " $loc\n", color = :light_black)
    print(io, "  output:   ")
    if isdirty(input)
        printstyled(io, "↻ $(input.output)\n", color = :light_black)
    else
        println(io, "✓ ", input.output)
    end
    print(io, "  dependents:")
    for v in input.dependents
        if isdirty(v)
            printstyled(io, "\n    ↻ $v", color = :light_black)
        else
            println(io, "\n    ✓ ", v)
        end
    end
    return
end


# TODO: Maybe keep track of edges in Graph?
function collect_edges(graph::ComputeGraph)
    cache = Set{ComputeEdge}()
    # recipes skip inputs when connecting so just checking inputs is not enough
    foreach(computed -> collect_edges(computed, cache), values(graph.outputs))
    return cache
end
function collect_edges(computed::Computed, cache::Set{ComputeEdge} = Set{ComputeEdge}())
    return collect_edges(computed.parent, cache)
end
function collect_edges(input::Input, cache::Set{ComputeEdge} = Set{ComputeEdge}())
    for edge in input.dependents
        collect_edges(edge, cache)
    end
    return cache
end
function collect_edges(edge::ComputeEdge, cache::Set{ComputeEdge})
    if !(edge in cache)
        push!(cache, edge)
        foreach(e -> collect_edges(e, cache), edge.dependents)
    end
    return
end
count_edges(graph::ComputeGraph) = length(collect_edges(graph))
count_edges(input::Input) = length(collect_edges(input))


function Base.show(io::IO, graph::ComputeGraph)
    N1 = length(graph.inputs)
    N2 = length(graph.outputs)
    N3 = count_edges(graph)
    return print(
        io, "ComputeGraph(",
        N1, " input$(N1 == 1 ? "" : 's'), ",
        N2, " output$(N2 == 1 ? "" : 's'), ",
        N3, " edge$(N3 == 1 ? "" : 's'))"
    )
end

function Base.show(io::IO, ::MIME"text/plain", graph::ComputeGraph)
    if isempty(graph.inputs) && isempty(graph.outputs)
        print(io, "ComputeGraph()")
        return io
    end

    println(io, "ComputeGraph():")

    print(io, "  Inputs:")
    ks = sort!(collect(keys(graph.inputs)), by = string)
    pad = mapreduce(k -> length(string(k)), max, ks, init = 0)
    for k in ks
        print(io, "\n    :", rpad(string(k), pad), " => ", graph.inputs[k])
    end

    print(io, "\n\n  Outputs:")
    ks = sort!(collect(keys(graph.outputs)), by = string)
    pad = mapreduce(k -> length(string(k)), max, ks, init = 0)
    for k in ks
        output = graph.outputs[k]
        print(io, "\n    :", rpad(string(k), pad), " => ")
        printstyled(io, "$output", color = ifelse(isdirty(output), :light_black, :normal))
    end
    return io
end


function Base.showerror(io::IO, re::ResolveException)
    trace_error(io, re.start)
    print(io, "Due to ")
    printstyled(io, "ERROR: ", color = :light_red, bold = true)
    Base.showerror(io, re.error)
end

function collect_dirty(computed::Computed, marked = Set{Symbol}())
    hasparent(computed) && collect_dirty(computed.parent, marked)
    return marked
end
function collect_dirty(edge::ComputeEdge, marked = Set{Symbol}())
    if !edge.got_resolved[] || any(edge.inputs_dirty)
        foreach(output -> push!(marked, output.name), edge.outputs)
        foreach(input -> collect_dirty(input, marked), edge.inputs)
    end
    return marked
end
function collect_dirty(edge::Input, marked = Set{Symbol}())
    edge.dirty && push!(marked, edge.name)
    return marked
end

# Error handling tools
function trace_error(io::IO, computed::Computed)
    print(io, "Failed to resolve ")
    printstyled(io, "$(computed.name):\n", color = :red)
    if hasparent(computed)
        marked = collect_dirty(computed)
        push!(marked, computed.name)
        trace_error(io, computed.parent, marked)
    end
    return
end
trace_error(io::IO, edge::ComputeEdge) = trace_error(io, edge, collect_dirty(edge))

function trace_error(io::IO, computed::Computed, marked)
    hasparent(computed) && trace_error(io, computed.parent, marked)
    return
end

function trace_error(io::IO, edge::ComputeEdge, marked)
    if isdirty(edge)
        print(io, "[ComputeEdge] ")

        outputs = join((output.name for output in edge.outputs), ", ")
        printstyled(io, outputs, color = :red)

        func = edge_callback_name(edge.callback, "")
        print(io, " = ", func, "((")

        N = length(edge.inputs)
        was_dirty = false
        for i in eachindex(edge.inputs)
            name = edge.inputs[i].name
            c = ifelse(was_dirty, :light_black, ifelse(name in marked, :red, :light_green))
            was_dirty |= name in marked # only mark first unresolved input
            printstyled(io, name, color = c)
            print(io, ", ")
        end
        println(io, "), changed, cached)")

        printstyled(io, "  @ $(edge_callback_location(edge))\n", color = :light_black)

        idx = findfirst(computed -> computed.name in marked, edge.inputs)
        if idx === nothing # All resolved
            print(io, "  with edge inputs:")
            ioc = IOContext(io, :limit => true)
            for input in edge.inputs
                print(io, "\n    ", input.name, " = ")
                show(ioc, input.value[])
            end
            println(io)
            print_root_inputs(io, edge)
        else # idx is first dirty
            trace_error(io, edge.inputs[idx], marked)
        end
    end
    return
end

function print_root_inputs(io::IO, edge::ComputeEdge)
    root_inputs = Set{Symbol}()
    for input in edge.inputs
        trace_inputs!(input, root_inputs)
    end
    return println(io, "Triggered by update of:\n  ", join(values(root_inputs), ", ", " or "))
end
function trace_inputs!(edge::ComputeEdge, root_inputs)
    foreach(c -> trace_inputs!(c, root_inputs), edge.inputs)
    return
end
function trace_inputs!(computed::Computed, root_inputs)
    hasparent(computed) && trace_inputs!(computed.parent, root_inputs)
    return
end
function trace_inputs!(input::Input, root_inputs)
    push!(root_inputs, input.name)
    return
end

function trace_error(io::IO, edge::Input, marked = nothing)
    print(io, "[Input] ")
    if edge.dirty
        printstyled(io, edge.name, color = :red)
        func = edge_callback_name(edge.f, "")
        println(io, " = ", func, '(', edge.value, ")")
        printstyled(io, "  @ $(edge_callback_location(edge))\n", color = :light_black)
    else
        printstyled(io, "$(edge.name)\n", color = :green)
    end
    return
end

"""
    show_inputs(node)

Traces and prints all recursive inputs to a node.
"""
show_inputs(node::Computed) = show_inputs(stdout, node)
function show_inputs(io::IO, node::Computed, tab = 0)
    println(io, "    "^tab, node)
    return show_inputs(io, node.parent, tab + 1)
end
function show_inputs(io::IO, node::Input, tab = 0)
    return println(io, "    "^tab, node)
end
function show_inputs(io::IO, edge::ComputeEdge, tab = 0)
    for node in edge.inputs
        show_inputs(io, node, tab)
    end
    return
end

using ComputePipeline
using Test
using Random

using ComputePipeline: InputFunctionWrapper, isdirty, ResolveException, map_latest!
using ComputePipeline.Observables

@testset "ComputePipeline.jl" begin
    # Sanity check for CI
    @test ComputePipeline.ENABLE_COMPUTE_CHECKS

    include("unit_tests.jl")
    include("system_tests.jl")
end

@testset "Full System Test" begin
    parent = ComputeGraph()
    add_input!(parent, :pin1, 1)
    add_input!(parent, :pin2, nothing)
    f32(x) = Float32.(x) # wrong on purpose
    add_input!(f32, parent, :pin3, [1, 2, 3])

    foo1((i, v), changed, outputs) = (v .- i, v .+ i)
    register_computation!(foo1, parent, [:pin1, :pin3], [:pout1, :pout3])

    foo2((x, i), changed, outputs) = (string(x, i),)
    register_computation!(foo2, parent, [:pin2, :pin1], [:pout2])

    @testset "Parent initialization" begin

        # Note:
        # These tests explicitly avoid checking dirty/resolved state and values of
        # output nodes because they are technically undefined at this point. They
        # are checked once the state of the graph is clear, i.e. after resolving
        # and updating.

        @testset "Inputs" begin
            @test length(parent.inputs) == 3

            for (name, val) in [(:pin1, 1), (:pin2, nothing), (:pin3, [1, 2, 3])]
                @test haskey(parent.inputs, name)
                @test haskey(parent.outputs, name)

                x = parent.inputs[name]
                @test x.name === name
                @test x.value == val
                @test x.output === parent.outputs[name]
                @test parent.outputs[name].parent === x
                @test parent.outputs[name].parent_idx == 1
            end

            @test parent.inputs[:pin1].f === identity
            @test parent.inputs[:pin2].f === identity
            @test parent.inputs[:pin3].f === InputFunctionWrapper(:pin3, f32)
        end

        @testset "Outputs" begin
            @test length(parent.outputs) == 6

            for name in [:pin1, :pin2, :pin3, :pout1, :pout2, :pout3]
                @test parent.outputs[name].name === name
            end
        end

        @testset "Structure/Edges" begin
            e1 = parent.outputs[:pout1].parent
            e2 = parent.outputs[:pout2].parent
            e3 = parent.outputs[:pout3].parent

            @test e1 === e3
            @test e1.callback === foo1
            @test isempty(e1.dependents)
            @test e1.inputs == [parent.outputs[:pin1], parent.outputs[:pin3]]
            @test e1.outputs == [parent.outputs[:pout1], parent.outputs[:pout3]]

            @test e2.callback === foo2
            @test isempty(e2.dependents)
            @test e2.inputs == [parent.outputs[:pin2], parent.outputs[:pin1]]
            @test e2.outputs == [parent.outputs[:pout2]]
        end
    end


    graph = ComputeGraph()
    add_input!(graph, :in1, 1)
    to_float(k, v) = Float32(v)
    add_input!(to_float, graph, :in2, 1)
    add_input!(graph, :in3, sin)
    add_input!(graph, :in4, :test)
    add_input!(graph, :trans2, parent[:pout2])
    to_int(k, x) = Int64.(x)
    add_input!(to_int, graph, :trans1, parent[:pout1])
    add_input!(to_int, graph, :trans3, parent[:pout3])

    reflect_inputs(inputs, changed, cached) = (values(inputs),)
    register_computation!(reflect_inputs, graph, [:in3, :in2, :in4], [:inputs324])

    reflect_changed(inputs, changed, cached) = (changed,)
    register_computation!(reflect_changed, graph, [:in1, :in3, :in2, :in4], [:changed1324])

    reflect_cached(inputs, changed, cached) = cached === nothing ? (rand(Int),) : (cached[1],)
    register_computation!(reflect_cached, graph, [:in1, :in4], [:cached14])

    discard(inputs, changed, outputs) = inputs[:in1] < 10 ? nothing : (inputs[1],)
    register_computation!(discard, graph, [:in1], [:discard10])

    merge_data(inputs, changed, outputs) = (inputs[1] .+ inputs[2],)
    register_computation!(merge_data, graph, [:trans1, :trans3], [:merged])


    @testset "Child initialization" begin
        @testset "Parent Graph Changes" begin
            e1 = parent.outputs[:pout1].parent
            e2 = parent.outputs[:pout2].parent

            @test length(e1.dependents) == 2
            @test length(e2.dependents) == 1
            @test e1.dependents[1] === graph.outputs[:trans1].parent
            @test e1.dependents[2] === graph.outputs[:trans3].parent
            @test e2.dependents[1] === graph.outputs[:trans2].parent
        end

        @testset "Inputs" begin
            @test length(graph.inputs) == 4

            for (name, val) in [(:in1, 1), (:in2, 1), (:in3, sin), (:in4, :test)]
                @test haskey(graph.inputs, name)
                @test haskey(graph.outputs, name)

                x = graph.inputs[name]
                @test x.name === name
                @test x.value == val
                @test x.output === graph.outputs[name]
                @test graph.outputs[name].parent === x
                @test graph.outputs[name].parent_idx == 1
            end

            @test graph.inputs[:in1].f === identity
            @test graph.inputs[:in2].f === InputFunctionWrapper(:in2, to_float)
            @test graph.inputs[:in3].f === identity
            @test graph.inputs[:in4].f === identity
        end

        output_names = [
            :in1, :in2, :in3, :in4,
            :trans1, :trans2, :trans3,
            :inputs324, :changed1324, :cached14, :discard10, :merged,
        ]

        @testset "Outputs" begin
            @test length(graph.outputs) == 12

            for name in output_names
                @test graph.outputs[name].name === name
            end
        end

        @testset "Structure/Edges" begin
            edges = [graph.outputs[name].parent for name in output_names]

            for i in 1:4
                @test edges[i] === graph.inputs[Symbol(:in, i)]
            end

            @test edges[5].callback === InputFunctionWrapper(:trans1, to_int)
            @test edges[5].dependents == [edges[12]]
            @test edges[5].inputs == [parent.outputs[:pout1]]
            @test edges[5].outputs == [graph.outputs[:trans1]]

            @test edges[6].callback === ComputePipeline.compute_identity
            @test isempty(edges[6].dependents)
            @test edges[6].inputs == [parent.outputs[:pout2]]
            @test edges[6].outputs == [graph.outputs[:trans2]]

            @test edges[7].callback === InputFunctionWrapper(:trans3, to_int)
            @test edges[7].dependents == [edges[12]]
            @test edges[7].inputs == [parent.outputs[:pout3]]
            @test edges[7].outputs == [graph.outputs[:trans3]]

            @test edges[8].callback === reflect_inputs
            @test isempty(edges[8].dependents)
            @test edges[8].inputs == getindex.(Ref(graph.outputs), [:in3, :in2, :in4])
            @test edges[8].outputs == [graph.outputs[:inputs324]]

            @test edges[9].callback === reflect_changed
            @test isempty(edges[9].dependents)
            @test edges[9].inputs == getindex.(Ref(graph.outputs), [:in1, :in3, :in2, :in4])
            @test edges[9].outputs == [graph.outputs[:changed1324]]

            @test edges[10].callback === reflect_cached
            @test isempty(edges[10].dependents)
            @test edges[10].inputs == getindex.(Ref(graph.outputs), [:in1, :in4])
            @test edges[10].outputs == [graph.outputs[:cached14]]

            @test edges[11].callback === discard
            @test isempty(edges[11].dependents)
            @test edges[11].inputs == [graph.outputs[:in1]]
            @test edges[11].outputs == [graph.outputs[:discard10]]

            @test edges[12].callback === merge_data
            @test isempty(edges[12].dependents)
            @test edges[12].inputs == getindex.(Ref(graph.outputs), [:trans1, :trans3])
            @test edges[12].outputs == [graph.outputs[:merged]]
        end
    end


    @testset "Updates" begin

        # Checking parents explicitly so code changes in node.parent and edge.inputs do
        # get caught

        # test initial state -> resolved state
        @testset "parent graph resolve state" begin
            @test parent[:pout2][] == "nothing1" # resolve
            @test !isdirty(parent.outputs[:pout2])
            @test !isdirty(parent.outputs[:pin1])
            @test !isdirty(parent.outputs[:pin2])
            @test !isdirty(parent.inputs[:pin1])
            @test !isdirty(parent.inputs[:pin2])
            @test parent.outputs[:pout2].value[] == "nothing1" # read
            @test parent.outputs[:pin1].value[] == 1
            @test parent.outputs[:pin2].value[] === nothing

            # Does not update child node
            @test isdirty(graph.outputs[:trans2])
        end

    end

    # graph & parent
    @test_throws ResolveException graph[:merged][] == [2, 4, 6]
    # needs to be in the same scope as previous f32 definition
    f32(key, x) = Float32.(x)

    @testset "Updates continued" begin

        @testset "child graph resolve state" begin
            @test graph.outputs[:merged][] == [2, 4, 6]
            @test !isdirty(graph.outputs[:trans1])
            @test !isdirty(graph.outputs[:trans3])
            @test !isdirty(parent.outputs[:pout1])
            @test !isdirty(parent.outputs[:pout3])
            @test !isdirty(parent.outputs[:pin3])
            @test graph.outputs[:trans1].value[] == Int64[0, 1, 2]
            @test graph.outputs[:trans3].value[] == Int64[2, 3, 4]
            @test parent.outputs[:pout1].value[] == Float32[0, 1, 2]
            @test parent.outputs[:pout3].value[] == Float32[2, 3, 4]
            @test parent.outputs[:pin3].value[] == Float32[1, 2, 3]
        end

        @testset "callback function" begin
            # check reflection nodes for correct inputs, changed, cached
            @test graph[:inputs324][] == (graph[:in3].value[], graph[:in2].value[], graph[:in4].value[])
            @test graph[:changed1324][] == (in1 = true, in3 = true, in2 = true, in4 = true)
            # If all are unchanged the update is skipped entirely so this is expected:
            @test graph[:changed1324][] == (in1 = true, in3 = true, in2 = true, in4 = true)
        end

        init = graph[:cached14][]

        # test resolved state -> dirty state
        @testset "update/dirty propagation" begin
            for v in values(parent.inputs)
                @test !isdirty(v)
            end
            for v in values(parent.outputs)
                @test !isdirty(v)
            end
            for v in values(graph.inputs)
                @test !isdirty(v)
            end
            for key in keys(graph.outputs)
                @test isdirty(graph.outputs[key]) == in(key, (:trans2, :discard10))
            end

            update!(graph, in1 = 11)
            @test isdirty(graph.inputs[:in1])
            @test isdirty(graph.outputs[:in1])
            @test isdirty(graph.outputs[:cached14])
            @test isdirty(graph.outputs[:changed1324])

            update!(parent, pin3 = [3, 2, 1])
            @test isdirty(parent.inputs[:pin3])
            @test isdirty(parent.outputs[:pin3])
            @test isdirty(parent.outputs[:pout1])
            @test isdirty(parent.outputs[:pout3])
            @test isdirty(graph.outputs[:trans1])
            @test isdirty(graph.outputs[:trans3])
            @test isdirty(graph.outputs[:merged])
        end

        # Since we didn't assume anything about the initial resolve/dirty state we
        # should tests dirty -> resolved state:
        @testset "child resolve after invalidation" begin
            # partial
            @test graph[:trans3][] == [4, 3, 2]
            @test !isdirty(graph.outputs[:trans3])
            @test !isdirty(parent.outputs[:pout3])
            @test !isdirty(parent.outputs[:pout1]) # same edge as pout3, so updated with pout3
            @test !isdirty(parent.outputs[:pin3])
            @test !isdirty(parent.inputs[:pin3])

            @test isdirty(graph.outputs[:trans1])
            @test isdirty(graph.outputs[:merged])

            # the rest
            @test graph[:merged][] == [6, 4, 2]
            @test !isdirty(graph.outputs[:merged])
            @test !isdirty(graph.outputs[:trans1])
            @test !isdirty(graph.outputs[:trans3])
            @test !isdirty(parent.outputs[:pout3])
            @test !isdirty(parent.outputs[:pout1]) # same edge as pout3
            @test !isdirty(parent.outputs[:pin3])
            @test !isdirty(parent.inputs[:pin3])
        end

        @testset "callback function" begin
            @test graph[:changed1324][] == (in1 = true, in3 = false, in2 = false, in4 = false)
            @test graph[:cached14][] == init
            @test graph[:discard10][] == 11
            update!(graph, in1 = 2)
            @test graph[:discard10][] == 11
            update!(graph, in1 = 22, in4 = :foo)
            @test graph[:discard10][] == 22
            @test graph[:cached14][] == init
            @test graph[:changed1324][] == (in1 = true, in3 = false, in2 = false, in4 = true)
            update!(graph, in2 = 0)
            @test graph[:changed1324][] == (in1 = false, in3 = false, in2 = true, in4 = false)
        end

    end
end
